define(['app', 'uicontrols'], function(App, $AppUI){

var BaseListView = App.view.base.extend({
	template: 
	'<table class="dwc_bases_table">' +
		'<thead>' +
			'<tr>' + 
				'<td data-i18="DbPath">' + App.helpers._('DbPath') + '</td>' +
				'<td data-i18="DbHash">' + App.helpers._('DbHash') + '</td>' +
				'<td data-i18="DbVirusRecords" style="white-space:normal;">' + App.helpers._('DbVirusRecords') + '</td>' +
				'<td data-i18="DbVersionAndCreationTime">' + App.helpers._('DbVersionAndCreationTime') + '</td>' +
			'</tr>' +
		'</thead>' +
		'<tbody>' +
		'<% if(obj.vdb_bases && obj.vdb_bases.length > 0) for(var i = 0, item; item = obj.vdb_bases[i], i < obj.vdb_bases.length; i++){ %>'+
			'<tr>' +
				'<td><%=item.path %></td>' +
				'<td><%=item.md5 %></td>' +
				'<td><%=item.virus_records %></td>' +
				'<td><%=item.version + " " +  obj._tools.time(item.timestamp) %></td>' +
			'</tr>' +
		'<% } else { %>' +
			'<tr>' +
				'<td data-i18="Db_empty_base_list" colspan="5" class="dwc_bases_empty-list">' + App.helpers._('Db_empty_base_list') + '</td>' +
			'</tr>' +
		'<% } %>' +
		'</tbody>' +
	'</table>',
	share: { // as obj._tools
		// Attention: localization of time() at parent model!
		time: App.helpers.timeFormatter(App.helpers._('DateStr')), // '%h:%m - %D.%M.%Y'
	},
	initialize: function(){
		App.view.base.prototype.initialize.call(this);
		this.listenTo(this.model, 'change', function(){
			this.render();
		});
		this.on('remove', function(){
			if(this.model){
				this.model.trigger('clear');
				this.model.clear({silent: true});
			}
		});
	}
});

	App.view.infoPage = App.view.base.extend({
		className: 'dwc_mainpage clearfix',
		template: 
		'<h3 class="dwc_page-title" data-i18="Information">' + App.helpers._('Information') + '</h3>' +
		'<div class="dwc_bases_group">' +
			'<h4 class="dwc_page-title3" data-i18="Console">' + App.helpers._('Console') + '</h4>' +
			'<div class="dwc_bases_liter1">' +
			    '<span data-i18="Version">' + App.helpers._('Version') + '</span> ' + App.i18n.get('appVersion') +
		    '</div>' +
		'<h4 class="dwc_page-title3" data-i18="DbList">' + App.helpers._('DbList') + '</h4>' +
		'<div>' +
			'<div data-co="baseinfo-block" class=""></div>' +
		'</div>',
		initialize: function(){
			App.view.base.prototype.initialize.call(this);
			this.addSubView('baseinfoBlock', new BaseListView({
				model: new App.model.info(null, {
					url: '/api/10.2/baseinfo'
				})
			}), 'baseinfo');
			this.refreshChild('baseinfo');
			this.listenTo(App.bus, 'refresh', function(e){
				if(e.event == 'baseinfo') this.refreshChild(e.event);
			});
			this.listenTo(App.i18n, 'change:lang', function(){
				if(this.children.baseinfoBlock){
					this.children.baseinfoBlock.render();
				}
			});
		},
		refreshChild: function(eventName){
			this.children[eventName] && this.children[eventName].model.loadData && this.children[eventName].model.loadData();
		},
	});

	return App.view.infoPage;
});	