define(['app', 'uicontrols'], function(App, $c){
	function getPass(id, secret, cb){
		return App.xhr.post('/api/10.2/idpass', {
			id: id,
			secret: secret
		}, function(d, r){
			cb(d);
		});
	}

	// TODO current tools for working with lexmap tree need refactoring.
	function getSettings(cb){
		App.xhr.get('/api/10.2/get_lexmap', {}, function(d, r){
			if(d && d.active){
				// Another properties
				// collectMap(d.master.option || [], '');
				// d.hardcoded.option || []
				cb(collectMap(d.active.option || []));
			}
		}.bind(this), 'json');
	}
	function collectMap(list){
		var 	out = {};
				i = list.length;
		
		while(i-- > 0){
			out[list[i].key] = collectProperties(list && list[i].map && list[i].map.option || []);
		}
		return out;
	};
	function collectProperties(list){
		var 	i = list.length,
				out = {};

		while(i-- > 0){
			if(list[i].value){
				out[list[i].key] = list[i].value.item;
			}else{
				out[list[i].key] = collectProperties(list && list[i].map && list[i].map.option || []);
			}
		}
		return out;
	}
	function parsePassword(str){
		var 	pos = str.indexOf('('),
				out = {}

		if(pos != -1){
			out.name = str.substring(0, pos);
			out.arg = str.substring(pos + 1, str.length - 1);
		}else{
			out.name = str;
		}
		return out;
	}
	
	return new $c.BasePopupView({
		class: 'dec_wt-popup dwc_mpp',
		title: App.helpers._('mpp_title'),
		destroyOnClose: false,
		content: 
		'<form class="dwc-form" data-co="form">' +
			'<button class="dwc_popup-close" type="reset"></button>' +
			'<div class="dwc_login-view_error" data-co="error" style="display:none;">' + App.helpers._('mpp_empty-field') + '</div>' +
			'<p class="dwc-mpp_instructions">' + App.helpers._('mpp_instructions') + '</p>' +
			'<table class="dwc-mpp_grid">' +
				'<tbody>' +
					'<tr>' +
						'<td>' + App.helpers._('mpp_id-label') + '</td>' +
						'<td>' + 
							'<span class="m3_middle">' + App.helpers._('mpp_secret-label') + '</span>' +
							'<i class="dwc_help-icon dwc-tooltip __black" data-title="' + App.helpers._('mpp_tooltip') + '"></i>' +
						'</td>' +
						'<td>&nbsp;</td>' +
					'</tr>' +
					'<tr>' +
						'<td>' +
							'<input type="text" class="dwc-mpp_input" data-co="message-id"/>' +
						'</td>' +
						'<td>' +
							'<input type="text" class="dwc-mpp_input" data-co="secret" placeholder="' + App.helpers._('mpp_secret-placeholder') + '"/>' +
						'</td>' +
						'<td>' +
							'<button class="dwc_btn __fit" type="submit" data-co="submit-btn">' + App.helpers._('mpp_submit-btn') + '</button>' +
						'</td>' +
					'</tr>' +
				'</tbody>' +
			'</table>' +
			'<div class="mpp_maild-pass-row" data-co="pass-row">' +
				App.helpers._('mpp_password-label') + 
				'<span class="mpp_maild-pass" data-co="pass-result"></span>' +
			'</div>' +
		'</form>' +
		'',
		onopen: function(view){
			view.controls.passRow.hide();
			view.controls.messageId.val('');
			this.controls.secret.val('');
			getSettings(function(setTree){
				var 	property = (setTree && setTree.MailD && setTree.MailD.RepackPassword || [])[0],
						options = parsePassword(property);

				if(options.name == 'HMAC'){
					view.controls.secret.val(options.arg);
				}
			});
		},
		onclose: function(view){
			_ValueModel = null;
		},
		_events: {
			'form submit': function(e){
				e.preventDefault();
				e.target.disabled = true;
				this.controls.error.hide();

				var 	messageId = this.controls.messageId.val(),
						mesSecret = this.controls.secret.val();

				if(messageId){
					getPass(messageId, mesSecret, function(pass){
						e.target.disabled = false;
						this.controls.passResult.text(pass);
						this.controls.passRow.show();
					}.bind(this));
				}else{
					this.controls.error.show();
				}
			},	
			'form reset': function(e){
				e.preventDefault();
				this.close();
			},
		}
	});
});
