define(['app', 'uicontrols'], function(App, $AppUI){

    function newItems(){
        var portsBlock = document.getElementById("portsBlock");
        newnode=document.createElement("div");
        newnode.className = "input_block";
        newitem = document.createElement("input");
        newitem.className = "dwc_validation-input_text additional-input";
        newitem.setAttribute('data-' + 'co', 'protected-input');
        newitem.setAttribute("required", true)
        portsBlock.appendChild(newnode);
        newnode.appendChild(newitem);
    }

return function(property, check, firewall, originalState){
    new $AppUI.BasePopupView({
            class: 'dec_wt-popup dec_wt-popup_change',
            content:
            '<button data-co="close" class="dwc_popup-close"></button>' +
            '<form class="dwc-form" data-co="form">' +
                '<div class="dwc_popup-header">' + App.helpers._('protect_incoming_connections') + '</div>' +
                '<div class="dwc-form_offset1" data-co="uploader-wrap"></div>' +
                '<div class="dwc-form_offset1">' +
                    '<label>' + App.helpers._('network_interface_name') + '</label>' + '<input type="text" class="dwc_validation-input_text" data-co="interface-input" required/>' +
                '</div>' +
                '<div class="dwc-form_offset1">' +
                    '<label>' + App.helpers._('protected_port') + '</label>' + '<div id="portsBlock" class="ports-block" data-co="ports"></div>' + '<label id="add-input">' + '<input type="button" data-co="addInput">' + App.helpers._('+_add_port') + '</label>' +
                '</div>' +
                '<div class="dwc-form_btn-wrap __left">' +
                    '<button class="dwc_btn __green" type="submit" data-i18="save_btn">' + App.helpers._('save_btn') + '</button>' +
                    '<button class="dwc_btn" data-co="cancel">' + App.helpers._('Cancel') + '</button>' +
                '</div>' +
            '</form>' +
            '',

            onopen: function(view){
                if (property != 'Off'){
                    var autoSettings = property.match(/\(interface:[\s]+([0-9A-z]+)[\s]+protected:[\s]+([0-9\,]+)/);
                    var interface = autoSettings[1];
                    var protected = autoSettings[2];
                    var ports = protected.split(',');
                    this.controls.interfaceInput.val(interface);

                    for (var i = 0; i < ports.length; i++) {
                        newItems();
                        newitem.value = ports[i];
                        if (i > 0) {
                            newitem2 = document.createElement("span");
                            newitem2.className = "trash-icon";
                            newnode.appendChild(newitem2);
                        }
                    }
                    var trash = document.getElementsByClassName('trash-icon');
                        for (var i = 0; i < trash.length; i++) {
                            var trashBtn = trash[i];                 
                            trashBtn.onclick = function() {
                                $(this).parent().remove();
                            }
                        }
                }else {
                    newItems();
                }

                view.controls.close.on('click', function(e){
                    e.preventDefault();
                    view.close();
                });
                view.controls.cancel.on('click', function(e){
                    e.preventDefault();
                    view.close();
                });
                view.controls.addInput.on('click', function(e){ 
                    newItems();
                    newitem2 = document.createElement("span");
                    newitem2.className = "trash-icon";
                    newnode.appendChild(newitem2);

                    var trash = document.getElementsByClassName('trash-icon');
                    for (var i = 0; i < trash.length; i++) {
                        var trashBtn = trash[i];
                    }
                    trashBtn.onclick = function() {
                        $(this).parent().remove();
                    }

                });
            },
            onclose: function(view){},
            _events: {
                'form submit': function(e){
                    e.preventDefault();

                    var properties = [],
                        buf;

                        buf = this.controls.interfaceInput.val();
                        buf && properties.push('interface:' + ' ' + buf);  

                        var inputs = [];
                        inputs.push(this.controls.ports.context.childNodes);

                        var arr = this.controls.ports.context.childNodes, 
                            buf = [];

                        for (var i = 0; i < arr.length; i++){
                            if (arr[i].classList.contains('input_block')){
                                j = arr[i].childNodes; 
                                 for (var a = 0; a < j.length; a++){
                                    if (j[a].hasAttribute('data-co', 'protected-input')){
                                        buf.push(j[a].value);
                                    }
                                }
                            }
                         }

                        buf && properties.push('protected:' + ' ' + buf);
                     
                        check.setAttribute('data-' + 'key', 'InputDivert');
                        check.setAttribute('data-' + 'value', 'Auto' + ' ' + '(' + properties.join(' ') + ')', 'Off');

                        var keyItem = check.dataset.key;
                        var values = check.dataset.value.split(', ');

                        firewall.changeState(originalState, function(d, app, status){
                        }, values, keyItem);

                        this.close();
                },
            }
        }).open();
    }
});