define(['app', 'uicontrols', 'backbone'], function (App, $AppUI, backbone) {
    var ErrorInfo = {
        open: function (code) {
            var _hashCode = code && this.EC_HASH[code];

            if (code) {
                new $AppUI.BasePopupView({
                    class: 'dec_doc-popup',
                    content:
                        '<button data-co="close" class="dwc_popup-close"></button>' +
                        '<form class="" data-co="form">' +
                        '<h3 class="dwc_help-title" data-co="title">' + App.helpers._(code) + '</h3>' +
                        '<div class="dwc-form_btn-wrap">' +
                        '<div class="dwc_help-support" data-co="support"></div>' +
                        '<button class="dwc_btn" data-co="submit">' + App.helpers._('Close') + '</button>' +
                        '</div>' +
                        '</form>' +
                        '',
                    onopen: function (view) {
                        view.controls.form.on('submit', function (e) {
                            e.stopPropagation();
                            e.preventDefault();
                            view.close();
                        });
                        view.controls.close.on('click', function (e) {
                            e.stopPropagation();
                            e.preventDefault();
                            view.close();
                        });

                        var frame = document.createElement('iframe'),
                            errorLink = '/help/' + App.i18n.helpSegment() + '/drweb-configd/error_' + _hashCode + '.htm',
                            onloadHandler = function () {
                                var _doc = frame.contentWindow.document.documentElement,
                                    height = _doc.offsetHeight;

                                frame.style.height = height + 'px';
                                view.controls.support.append(App.helpers.patterns.parseStrWithNodes(App.helpers._('contact_technical_support')));
                            };

                        frame.className = 'dwc_help-frame';
                        view.controls.title.after(frame);

                        // Check if page exist
                        $.get(errorLink).done(function (content, x) {
                            frame.onload = onloadHandler;

                            // if(frame.srcdoc != undefined){
                            if (false) {
                                var match = /\<body[^\>]+\>([\s\S]+)\<\/body\>/i.exec(content);

                                if (match[1]) {
                                    frame.srcdoc = '<link type="text/css" href="/doc/normalize.css" rel="stylesheet">' +
                                        '<link type="text/css" href="/help/' + App.i18n.helpSegment() + '/drweb-configd/default.css" rel="stylesheet">' +
                                        match[1];
                                }
                            } else { // fallback for IE10+
                                // Links would not be work. So H&M generate wasted code, and IE can't clean it. Change target="_blank" to target="_top"
                                frame.src = errorLink;
                                frame.sandbox = 'allow-same-origin allow-top-navigation allow-popups'; // allow-popups - turn on links with target="_blank/_top"

                                var $links = frame.contentWindow.document.querySelectorAll('[target=_blank]'),
                                    i = $links.length;

                                while (i-- > 0) {
                                    $links[i].setAttribute('target', '_top');
                                }
                            }
                        }).fail(function () {
                            frame.onload = onloadHandler;
                            frame.src = '/help/' + App.i18n.helpSegment() + '/drweb-configd/error_default.htm';
                            frame.sandbox = 'allow-same-origin allow-top-navigation allow-popups';
                        });
                    }
                }).open();
            }
        },
        EC_HASH: {
            EC_OK: 0,
            EC_MONITOR_IPC_ERROR: 1,
            EC_ALREADY_IN_PROGRESS: 2,
            EC_IN_PENDING_STATE: 3,
            EC_INTERRUPTED_BY_USER: 4,
            EC_CANCELED: 5,
            EC_LINK_DISCONNECTED: 6,
            EC_BAD_MESSAGE_SIZE: 7,
            EC_BAD_MESSAGE_FORMAT: 8,
            EC_NOT_READY: 9,
            EC_NOT_INSTALLED: 10,
            EC_UNEXPECTED_MESSAGE: 11,
            EC_PROTOCOL_VIOLATION: 12,
            EC_NOT_ABSOLUTE_PATH: 20,
            EC_NO_MEMORY: 21,
            EC_IO_ERROR: 22,
            EC_NO_SUCH_ENTRY: 23,
            EC_PERMISSION_DENIED: 24,
            EC_NOT_A_DIRECTORY: 25,
            EC_DATA_CORRUPTED: 26,
            EC_FILE_EXISTS: 27,
            EC_READ_ONLY_FS: 28,
            EC_NETWORK_ERROR: 29,
            EC_NOT_A_DRIVE: 30,
            EC_UNEXPECTED_EOF: 31,
            EC_FILE_WAS_CHANGED: 32,
            EC_NOT_A_REGULAR_FILE: 33,
            EC_NAME_ALREADY_IN_USE: 34,
            EC_HOST_OFFLINE: 35,
            EC_BASE_CORRUPTED: 40,
            EC_OLD_BASE_VERSION: 41,
            EC_EMPTY_BASE: 42,
            EC_CAN_NOT_BE_CURED: 43,
            EC_INVALID_BASE_SET: 44,
            EC_SCAN_LIMIT_REACHED: 45,
            EC_AUTH_FAILED: 47,
            EC_NOT_AUTHORIZED: 48,
            EC_INVALID_TOKEN: 49,
            EC_INVALID_ARGUMENT: 60,
            EC_INVALID_OPERATION: 61,
            EC_ROOT_ONLY: 62,
            EC_STANDALONE_MODE_ONLY: 63,
            EC_NON_SUPPORTED_OS: 64,
            EC_NOT_IMPLEMENTED: 65,
            EC_UNKNOWN_OPTION: 66,
            EC_UNKNOWN_SECTION: 67,
            EC_INVALID_OPTION_VALUE: 68,
            EC_INVALID_STATE: 69,
            EC_NOT_LIST_OPTION: 70,
            EC_INVALID_TAG: 71,
            EC_RECORD_NOT_FOUND: 80,
            EC_RECORD_BUSY: 81,
            EC_QUARANTINED_FILE: 82,
            EC_BAD_DRL_FILE: 90,
            EC_BAD_LST_FILE: 91,
            EC_BAD_LZMA_FILE: 92,
            EC_PROXY_AUTH_ERROR: 93,
            EC_NO_UPDATE_SERVERS: 94,
            EC_BAD_KEY_FORMAT: 95,
            EC_EXPIRED_KEY: 96,
            EC_NETWORK_TIMEDOUT: 97,
            EC_BAD_CHECKSUM: 98,
            EC_BAD_TRIAL_KEY: 99,
            EC_BLOCKED_LICENSE: 100,
            EC_BAD_LICENSE: 101,
            EC_BAD_CONFIG: 102,
            EC_BAD_EXECUTABLE: 104,
            EC_NO_CORE_ENGINE: 105,
            EC_NO_VIRUS_BASES: 106,
            EC_APP_TERMINATED: 107,
            EC_APP_CRASHED: 108,
            EC_INCOMPATIBLE: 109,
            EC_BAD_VADERETRO_LIB: 110,
            EC_NO_LOOKUPD: 115,
            EC_NO_VPND: 116,
            EC_NO_GATED: 117,
            EC_NO_MAILD: 118,
            EC_NO_SCAN_ENGINE: 119,
            EC_NO_FILE_CHECK: 120,
            EC_NO_ESAGENT: 121,
            EC_NO_FIREWALL: 122,
            EC_NO_NET_CHECK: 123,
            EC_NO_CLOUDD: 124,
            EC_UNEXPECTED_ERROR: 125,
            EC_NO_KERNEL_MODULE: 113, // TODO
        },
    };

    //// * * * License infoBlock * * *
    App.model.licenseBlock = App.model.infoBlock.extend({
        url: '/api/10.2/keyinfo',
        loadData: function () {
            var _model = this;
            this.fetch({
                type: 'GET',
                contentType: 'application/json',
                success: function (m, r, obj) { },
                error: function (m, r, obj) { },
                parse: function (obj) {
                    // force clearing model:
                    _model.clear({ silent: true });
                    return obj
                }
            });
        },
    });

    // Attention: Если лицензия просрочена, его номер будет отдаваться 
    App.view.licenseBlock = App.view.base.extend({
        className: 'dwc_license-block',
        render: function () {
            var template = '',
                obj = this.model.toJSON(),
                leftTimeData;

            if (obj.es_mode) {
                template += '<h3 class="dwc_page-title">' + _.escape(App.helpers._('license')) + '</h3>';
                template += '<div class="dwc_update-block_wrap">' + _.escape(App.helpers._(obj.key ? 'license_granted_by_protection_server' : 'central_protection_server_has_not_granted_a_license')) + '</div>';
                // The central protection server has not granted a license to this computer.    
            } else if (obj.key && obj.key.number && obj.key.expiration_time) {
                leftTimeData = this.share.leftTime(obj.key.expiration_time);

                if (!leftTimeData.isFinish) {
                    template += '<h3 class="dwc_page-title">' + _.escape(App.helpers._('license')) + '</h3>';
                    template += '<div class="dwc_update-block_wrap">';
                    template += '<div class="dwc_page-block_left">' + _.escape(App.helpers._('licenseNumber')) + '</div>' +
                        '<div class="dwc_license-block_right">' + _.escape(obj.key.number) + '</div>';
                    template += '<div class="dwc_page-block_left">' + _.escape(App.helpers._('activationDate')) + '</div>' +
                        '<div class="dwc_license-block_right">' + this.share.time(obj.key.activation_time) + '</div>';
                    template += '<div class="dwc_page-block_left">' + _.escape(App.helpers._('expirationDate')) + '</div>' +
                        '<div class="dwc_license-block_right">' + this.share.time(obj.key.expiration_time) + '</div>' +
                        '<div class="dwc_page-block_left">' + leftTimeData.label + '</div>' +
                        '<div class="dwc_license-block_right">' + leftTimeData.text + '</div>';
                    template += '</div>';
                    template += '<button class="dwc_btn">' + _.escape(App.helpers._('extend')) + '</button>';
                } else {
                    template += '<h3 class="dwc_page-title __warning">' + _.escape(App.helpers._('license')) + '</h3>';
                    template += '<div class="dwc_update-block_wrap clearfix">';
                    template += '<div class="dwc_warning">' + _.escape(App.helpers._('license_expired')) + '</div>';
                    template += '</div>';
                    template += '<button class="dwc_btn">' + _.escape(App.helpers._('get_a_new_license')) + '</button>'; // TODO show another popup\
                }
            } else {
                template += '<h3 class="dwc_page-title __warning">' + _.escape(App.helpers._('license')) + '</h3>';
                template += '<div class="dwc_update-block_wrap cleafix"><div class="dwc_warning">' + _.escape(App.helpers._('license_not_installed')) + '</div></div>';
                template += '<button class="dwc_btn">' + _.escape(App.helpers._('purchase_license')) + '</button>'; // спросить, будет ли такой кейс???
            }

            this.el.innerHTML = template;
            return this;
        },
        share: {
            _: App.helpers._,
            time: App.helpers.timeFormatter(App.helpers._('DateStr')), // '%h:%m - %D.%M.%Y'
            leftTime: function (expDate) {
                var now = Date.now(),
                    exp = expDate * 1000,
                    obj = App.helpers.timeLeft(now, exp),
                    template, value;

                if (obj.d != 0) {
                    template = '5_days_left';
                    value = Math.abs(obj.d);
                } else if (obj.h != 0) {
                    template = '5_hours_left';
                    value = Math.abs(obj.h);
                } else if (obj.m != 0) {
                    template = '5_minutes_left';
                    value = Math.abs(obj.m);
                }

                return {
                    isFinish: now > exp,
                    label: (exp > now ? App.helpers._('left') : App.helpers._('passed')), // Time passed
                    text: App.helpers.plurals(value, App.i18n.get('lang'), App.helpers._(template)).replace('%d', value)
                };
            }
        },
        initialize: function () {
            // this.render(this.i18);
            // this.children = {};
            App.view.base.prototype.initialize.call(this);

            this.listenTo(this.model, 'change', function () {
                this.render();
            }.bind(this));
            this.listenTo(App.i18n, 'change:lang', function (model, lang) {
                this.share.time = App.helpers.timeFormatter(App.helpers._('DateStr'));
                this.render();
            });
            this.on('remove', function () {
                this.model && this.model.clear({ silent: true });
            });
        },
        events: {
            'click button': function () {
                new $AppUI.BasePopupView({
                    class: 'dec_wt-popup',
                    content: // main content
                        '<button data-co="close" class="dwc_popup-close"></button>' +
                        '<form class="dwc-form" data-co="form">' +
                        '<h3 class="dwc_page-title2">' + App.helpers._('activate_license') + '</h3>' +
                        '<div class="dwc-form_offset2 dwc_popup_label1">' + App.helpers._('activation_select_key') + '</div>' +
                        '<div class="dwc-form_offset1" data-co="uploader-wrap"></div>' +
                        '<div class="dwc-form_offset3">' +
                        '<button type="submit" class="dwc_btn __green" disabled data-co="upload">' + App.helpers._('activate_license') + '</button>' +
                        '</div>' +
                        '<div class="dwc-form_offset2 dwc_popup_label2">' + App.helpers._('activation_if_you_dont_have_a_key') + '</div>' +
                        '<a href="https://products.drweb.ru/" target="_blank" class="dwc_popup_extlink">' + App.helpers._('activation_buy_license') + '</a>' +
                        '</form>' +
                        '',
                    onopen: function (view) {
                        var $uploadBtn = view.controls.upload,
                            _uploader = new $AppUI.FileUploaderView({
                                btnLabel: App.helpers._('Review'),
                                onchange: function (value, e, files) {
                                    view._files = files;
                                    _uploader.addWarning();

                                    if (value) {
                                        $uploadBtn.removeAttr('disabled');
                                    } else {
                                        $uploadBtn.attr('disabled', true);
                                    }
                                },
                                onread: function (part, chunk, chunks, next) {
                                    $uploadBtn.attr('disabled', true);
                                    App.xhr.objPost({
                                        url: '/api/10.2/install_license',
                                        resFormat: 'json',
                                        oncomplete: function (r, x) {
                                            var errorMessage;

                                            if (x.ec == 'EC_EXPIRED_KEY') { // лицензия просрочена
                                                errorMessage = App.helpers._('license_key_file_overdue');
                                            } else if (x.ec == 'EC_BAD_KEY_FORMAT') {
                                                errorMessage = App.helpers._('unsupported_key_file_format');
                                            } else if (x.ec) {
                                                errorMessage = App.helpers._(x.ec);
                                            }

                                            if (errorMessage) {
                                                _uploader.addWarning(errorMessage);
                                                $uploadBtn.removeAttr('disabled');
                                            } else if (chunk == chunks) { // send last chunk
                                                view.close();
                                                $uploadBtn.removeAttr('disabled');
                                            }
                                            next && next();
                                        },
                                        params: part, //  window.btoa(part), App.base64.encode(part)
                                    });
                                }
                            });

                        view.controls.uploaderWrap.prepend(_uploader.el);
                        view.on('remove', function () {
                            _uploader.remove();
                        });
                        view.controls.close.on('click', function (e) {
                            e.stopPropagation();
                            e.preventDefault();
                            view.close();
                        });
                        view.controls.form.on('submit', function (e) {
                            e.preventDefault();
                            if (!view.controls.upload[0].hasAttribute('disabled') && view._files) {
                                _uploader.readFiles(view._files);
                            }
                        });
                    },
                    onclose: function (view) { },
                }).open();
            }
        }
    });

    //// * * * Update infoBlock * * *
    App.model.updateBlock = App.model.infoBlock.extend({
        defaults: {
            last_success_time: 0,
            next_update_time: 0,
            last_attempt: undefined,
            progress: undefined,
            // time_stamp: 0, // time of request (DEPRICATED)
        },
        initialize: function () {
            this.startUpdate(function (r) {
                if (r !== 'EC_STANDALONE_MODE_ONLY') {
                    this.trigger('error', r);
                }
            }.bind(this));
        },
        url: '/api/10.2/updateinfo',
        loadData: function () {
            var _model = this;
            this.fetch({
                type: 'GET',
                contentType: 'application/json',
                parse: function (obj) {
                    // Attention!
                    // From backend we get new values and we must delete old, not updated fields with two ways.
                    // force clearing model (Another solution is set undefined for other properties)
                    // _model.clear({silent: true});
                    if (!obj || !obj.updateinfo) {
                        return {};
                    }

                    if (!obj.updateinfo.progress) {
                        obj.updateinfo.progress = null;
                    }
                    return obj.updateinfo;
                }
            });
        },
        startUpdate: function (cb) {
            App.xhr.post('/api/10.2/start_update', null, function (d, r) {
                if (r.sessionComplete) return;

                if (r.ec) {
                    // App.helpers.notify(App.helpers._('Error'), App.helpers._(r.ec));
                    this.trigger('change', this); // force model change to unlock buttons
                    cb(r.ec);
                }

                this.set('current_attempt_id', d && d.start_update && d.start_update.attempt_id);
            }.bind(this));
        },
        // @param {Function} cb - oncomplete callback
        stopUpdate: function (cb) {
            App.xhr.post('/api/10.2/stop_update', null, function (d, r) {
                if (r.sessionComplete) return;
            });
            cb && cb();
        },
        percent: function (part, total) {
            return ~~(100 - 100 * (total - part) / total);
        }
    });


    App.view.updateBlock = App.view.base.extend({
        className: 'dwc_update-block',
        template:
            '<h3 class="dwc_page-title" data-i18="Updates"></h3>' +
            '<div class="dwc_update-block_wrap">' +
            '<div style="display:none;" data-co="last-attempt" class="dwc_update-warning-wrap"><a href="javascript:void(0)" class="dwc_elements_error-status" data-co="error-status" data-i18="Error"></a></div>' +
            '<div style="display:none;" data-co="update-not-required" class="dwc_update-block_required-block"><div class="dwc_alertline"></div></div>' + // inner <div> for text label

            '<div data-co="time-block">' +
            '<div style="display:none;" data-co="lst-wrap">' +
            '<div class="dwc_page-block_left" data-i18="lastUpdateDate"></div>' +
            '<div class="dwc_update-block_right" data-co="lst"></div>' +
            '</div>' +
            '<div style="display:none;" data-co="nut-wrap">' +
            '<div class="dwc_page-block_left" data-i18="nextUpdateDate"></div>' +
            '<div class="dwc_update-block_right" data-co="nut"></div>' +
            '</div>' +
            '</div>' +
            '<div class="dwc_update-block_progress-block" data-co="progress-block">' +
            '<div class="dwc_update-block_progress-line" data-co="progress-wrap" style="display:none;">' +
            '<div class="dwc_update-block_progress" data-co="progress" style=""></div>' +
            '<div class="dwc_update-block_label" data-co="progress-label"></div>' +
            '</div>' +
            // '<div class="dwc_update-block_progress-title" data-co="stage-title" style="display: none;"></div>' +
            '<div class="dwc_update-block_progress-size" data-co="progress-advice" style="display:none;"></div>' +
            '<div class="dwc_update-block_progress-text" data-co="progress-text" style="display:none;"></div>' +
            '</div>' +
            '</div>' +
            '<button class="dwc_btn" data-co="btn" data-i18="Update"></button>' +
            '' +


            '<div class="dwc_popup dwc_mpp dec_wt-popup" tabindex="0" data-co="new-update" style="display:none;">' +
            '<div class="dwc_popup-wrap">' +
            '<div class="dwc_popup-content" data-co="content">' +
            '<button data-co="close-update" class="dwc_popup-close"></button>' +
            '<div class="dwc_popup-header" data-co="popup-title">' + App.helpers._('update_version') + '</div>' +
            '<div class="dwc_popup-body clearfix" data-co="body">' +
            '<div class="dwc-mpp_instructions" style="    white-space: pre" data-co="update-version-content">' +
            '</div>' +
            '</div>' +
            '</div>' +
            '<div class="m3_middle_helper"></div>' +
            '</div>' +
            '</div>'
        ,
        time: App.helpers.timeFormatter(App.helpers._('DateStr')),
        initialize: function () {
            App.view.base.prototype.initialize.call(this);
            this.listenTo(this.model, 'change:last_success_time', function (model, value) { // время последнего удачного обновления

                if (value) {
                    this.controls.lstWrap.show();
                    this.controls.lst.text(this.time(value));
                } else {
                    this.controls.lstWrap.hide();
                }
            });
            this.listenTo(this.model, 'change:next_update_time', function (model, value) { // время следующего обновления
                if (value) {
                    this.controls.nutWrap.show();
                    this.controls.nut.text(this.time(value));
                } else {
                    this.controls.nutWrap.hide();
                }
            });

            this.listenTo(this.model, 'change:version_info', function (model, value) { // время version_info   
                if (value.current_version_outdated) {
                    this.controls.newUpdate.show()
                    var _this = this;
                    this.controls.closeUpdate.on('click', function (e) {
                        e.stopPropagation();
                        e.preventDefault();
                        _this.controls.newUpdate.hide();
                    });


                    var content = App.helpers._('update_version-text').replace('%d', value.version) +
                        ' <a href="https://news.drweb.com" target="_blank" class="dwc_popup_extlink">https://news.drweb.com</a>';

                        this.controls.updateVersionContent.html(content)
                }

            });

            this.listenTo(this.model, 'change:last_attempt', function (model, last_attempt) { // Ошибка обновления
                if (last_attempt && last_attempt.exit_code && last_attempt.exit_code != 'EC_OK') {
                    var labelText = App.helpers._(last_attempt.exit_code);
                    this.controls.errorStatus.text(labelText);
                    this.controls.errorStatus.addClass('__inited');
                    this.controls.errorStatus.show();
                    this.controls.lastAttempt.attr('title', App.helpers._(last_attempt.exit_code)).show();
                } else {
                    this.controls.lastAttempt.hide();
                }
            });
            this.listenTo(this.model, 'error', function (ec) { // время следующего обновления
                ErrorInfo.open(ec);
            });
            this.listenTo(App.i18n, 'change:lang', function () {
                this.localize();
            });
            // DEPRICATED
            // this.listenTo(this.model, 'change:time_stamp', function(m){
            //  this.controls.btn.prop('disabled', false);
            // });
            this.listenTo(this.model, 'change', function (m) {
                var last_attempt = m.changed.last_attempt,
                    current_attempt_id = m.get('current_attempt_id'),
                    progress = m.get('progress');

                if (last_attempt && current_attempt_id && last_attempt.attempt_id == current_attempt_id) {
                    this.controls.updateNotRequired.show().removeClass('__close');

                    if (COMP_SUCCESS[last_attempt.exit_code]) {
                        this.controls.updateNotRequired.children(0).
                            text(App.helpers._('Update_is_not_required'));
                    } else {
                        this.controls.updateNotRequired.hide()
                        this.controls.errorStatus.text(App.helpers._('update_failed')).show();
                    }
                } else {
                    this.controls.updateNotRequired.hide().removeClass('__close');
                }

                if (progress) {
                    var stage = progress.stage,
                        percent = '0%',
                        progressText = '';

                    this.controls.timeBlock.hide();
                    this.controls.progressWrap.show();

                    if (stage == 'PREPARING') {
                        this.controls.btn.prop('disabled', true);
                    } else if (stage == 'CHECKING' || stage == 'DOWNLOADING') {
                        this.controls.btn.prop('disabled', false);
                        this.controls.btn.text(App.helpers._('Cancel')).data('i18', 'Cancel');
                    }

                    var bytesDimensions = ['vol_B', 'vol_Kb', 'vol_Mb', 'vol_Gb', 'vol_Tb'].map(function (k) { return ' ' + App.helpers._(k); });

                    if (progress.check) {
                        percent = m.percent(progress.check.bytes_checked, progress.check.bytes_to_check) + '%';
                        progressText = App.helpers._('update_checking').replace('%1', App.helpers.formatBytes(progress.check.bytes_checked, bytesDimensions));
                        this.controls.progressAdvice.show().text(App.helpers._('update_original').replace('%1', App.helpers.formatBytes(progress.check.bytes_to_check, bytesDimensions)));
                    } else if (progress.download) {
                        percent = m.percent(progress.download.bytes_processed, progress.download.bytes_to_process) + '%';
                        this.controls.progressAdvice.show().text(App.helpers._('update_original').replace('%1', App.helpers.formatBytes(progress.download.bytes_to_process, bytesDimensions)));
                        progressText = App.helpers._('update_downloading').replace('%1', App.helpers.formatBytes(progress.download.bytes_processed, bytesDimensions));
                    } else {
                        this.controls.progressAdvice.hide();
                        progressText = App.helpers._('update_preparing');
                    }
                    this.controls.progressText.show().text(progressText);
                    this.controls.progressLabel.text(percent);
                    this.controls.progress.css('width', percent);
                } else {
                    this.controls.timeBlock.show();
                    this.controls.btn.prop('disabled', false);
                    this.controls.btn.text(App.helpers._('Update')).data('i18', 'Update');
                    // this.controls.stageTitle.hide();
                    this.controls.progressAdvice.hide();
                    this.controls.progressWrap.hide();
                    this.controls.progressText.hide();
                }
            });

            this.on('remove', function () {
                if (this.model) {
                    this.model.trigger('clear');
                    this.model.clear({ silent: true });
                }
            });
            this.localize();
            // Attention your can check if collection completed by App.collection.installed.length
            this.listenTo(App.collection.installed, 'reset', function (c) {
                if (c.get('APP_UPDATE') != undefined) { // Udate installed
                    this.controls.btn.prop('disabled', false);
                } else {
                    this.controls.btn.prop('disabled', true);
                }
            });
        },
        localize: function () {
            this.time = App.helpers.timeFormatter(App.helpers._('DateStr'));

            var value; // fix time formatting
            value = this.model.get('next_update_time');
            value && this.controls.nut.text(this.time(value));
            value = this.model.get('last_success_time');
            value && this.controls.lst.text(this.time(value));
        },
        events: {
            'click [data-co=btn]': function () {
                this.controls.btn.prop('disabled', true);
                var model = this.model;

                if (this.model.get('progress')) {
                    this.model.stopUpdate(function () {
                        model.set('progress', null);
                    });
                } else {
                    this.model.startUpdate(function (r) {
                        this.model.trigger('error', r);
                    }.bind(this));
                }
            },
            'click [data-co=error-status]': function (e) {
                ErrorInfo.open(this.model.get('last_attempt').exit_code);
            }
        }
    });

    var COMP_DATA_HOST = {
        APP_NET_CHECK: '/api/10.2/netcheck_appinfo',
        APP_MAILD: '/api/10.2/maild_appinfo',
        APP_FIREWALL: '/api/10.2/firewall_appinfo',
        APP_MAC_SPIDER: '/api/10.2/mac_spider_appinfo',
        APP_LINUX_SPIDER: '/api/10.2/linux_spider_appinfo',
        APP_LINUX_NSS: '/api/10.2/nss_appinfo',
        APP_GATED: '/api/10.2/gated_appinfo',
        // APP_ESAGENT: '/api/10.2/esagent_appinfo', // Was used at esconnection page
        APP_SCAN_ENGINE: '/api/10.2/scan_engine_appinfo',
    },
        COMP_DATA_PROP = {
            APP_NET_CHECK: ['local_se_forks', 'remote_se_forks', 'ec'],
            APP_GATED: ['state'],
            APP_MAILD: ['ec'],
            APP_FIREWALL: ['ec'],
            APP_MAC_SPIDER: ['state'],
            APP_LINUX_SPIDER: ['state'],
            APP_LINUX_NSS: ['socket_path'],
            APP_SCAN_ENGINE: ['max_forks']
        },
        COMP_BLACK_LIST = {
            APP_CONFIGD: 1,
            APP_HTTPD: 1,
        },
        COMP_STARTABLE = { // origin: ini_root
            APP_HTTPD: 'HTTPD',
            APP_SNMPD: 'SNMPD',
            APP_CLAMD: 'ClamD',
            APP_ICAPD: 'ICAPD',
            APP_SMB_SPIDER: 'SMBSpider',
            APP_MAC_FIREWALL: 'MacFirewall',
            APP_MAC_SPIDER: 'MacSpider',
            APP_LINUX_SPIDER: 'LinuxSpider',
            APP_LINUX_NSS: 'NSS',
            APP_VPND: 'VPND',
        },
        PRIMARY_COMPONENTS = { // exist and priority for sort
            APP_SMB_SPIDER: 6,
            APP_LINUX_NSS: 6,
            APP_LINUX_SPIDER: 5,
            APP_MAC_SPIDER: 5,
            APP_ICAPD: 4,
            APP_LINUX_FIREWALL: 3,
            APP_MAC_FIREWALL: 3,
            APP_CLAMD: 2,
            APP_CONFIGD: 1,
        },
        COMP_SUCCESS = {
            EC_OK: 1,
            EC_APP_TERMINATED: 1,
            EC_LINK_DISCONNECTED: 1
        },
        SUB_COMPONENTS = {
            dws: 'DWS',
            maild: 'MailD',
            vaderetro: 'Vaderetro',
            dnsxl: 'DNSXL',
            scan: 'NetCheck',
            gated: 'GateD'
        };

    var StartableComponents = backbone.Model.extend({
        url: '/api/10.2/get_lexmap',
        parse: function (r) {
            var compCollection = {},
                start,
                list = r.active.option,
                i = list.length;
            while (i-- > 0) {
                var innerList = list && list[i].map && list[i].map.option,
                    j = Array.isArray(innerList) && innerList.length;

                if (j > 0) {
                    while (j-- > 0) {
                        if (innerList[j].key == 'Start') {
                            if (start = innerList[j].value && innerList[j].value.item) {
                                compCollection[list[i].key] = start[0];
                                break;
                            }
                        }
                        if (innerList[j].key == 'InputDivert' || innerList[j].key == 'OutputDivert') {
                            if (!compCollection[list[i].key]) {
                                compCollection[list[i].key] = {};
                            }
                            if (divert = innerList[j].value && innerList[j].value.item) {
                                compCollection[list[i].key][innerList[j].key] = divert[0];
                            }
                        }
                    }
                }
            }
            return compCollection;
        },
        isStarted: function (iniSection) {
            var res = this.get(iniSection);

            return res && res.get('Start') == 'Yes';
        }
    })

    //// * * * ComponentsBlock *** 
    // TODO run at several tabs `drweb-ctl scan /usr` -> run severel installs of ctl
    // testCollection.fetch({reset:true})
    App.model.Component = Backbone.Model.extend({
        defaults: {
            app: '', // default component id
            name: '', // human readable name
        },
        // Attention: APP_ESAGENT and APP_ESCAN have one pid number!
        // idAttribute: 'pid', // use pid instead of app, to catch changes
        idAttribute: 'app',
        compWithoutStat: {
            APP_SNMPD: 1,
            APP_LINUX_FIREWALL: 1,
            APP_MAC_FIREWALL: 1,
            APP_UPDATE: 1,
            APP_CLOUDD: 1,
            APP_ESAGENT: 1,
            APP_LOOKUPD: 1,
            APP_FILE_CHECK: 1,
        },
        parse: function (resp) {
            resp.name = App.helpers._(resp.app) || resp.app;
            resp.startable = !!COMP_STARTABLE[resp.app];

            if (!this.compWithoutStat[resp.app]) {
                resp.file_stat = '';
                resp.error_stat = '';
            }

            return resp;
        },
        // @param {Bool} turnOn
        changeState: function (turnOn, cb, values, keyItem) {
            var app = this.get('app'),
                section = this.get('ini_section');
            values = values || ['Yes', 'No'];
            keyItem = keyItem || 'Start';

            // if (!COMP_STARTABLE[app]) {
            //  cb && cb(null, app, null);
            //  return;
            // }

            var componentId = this.get('bid'),
                data = {
                    option: [{
                        key: section,
                        map: {
                            option: [{
                                key: keyItem,
                                value: {
                                    item: [turnOn ? values[0] : values[1]]
                                }
                            }]
                        }
                    }]
                };

            var xhr = App.xhr.post('/api/10.2/set_lexmap', data, function (d, r) {
                cb && cb(d, app, turnOn);
            });
            // kill request after 6 sec.
            setTimeout(function () {
                xhr.abort();
            }, 6000);
        },

        initialize: function (c) {
            this.attributes = this.parse(this.attributes);
        },
        isBroken: function () {
            var exitCode = this.get('exit_code'),
                iniStart = this.get('ini_start'),
                isBroken = false;

            if (this.get('exit_time')) {
                if (exitCode != 'EC_OK' && exitCode != 'EC_APP_TERMINATED' && exitCode != 'EC_LINK_DISCONNECTED') {
                    if (!iniStart || iniStart == 'Yes') {
                        isBroken = true;
                    }
                }
            }

            return isBroken;
        },
        isDisable: function () {
            return this.get('swicth_on_time') != undefined;
        },
        isWork: function () {
            return !this.get('exit_time') && (this.get('switch_on_time') || this.get('pid'));
        },
        isExtension: function () {
            return this.get('extension') != undefined;
        },
        updateProperty: function (key, value, cb) {
            var componentId = this.get('bid'),
                data = {
                    option: [{
                        key: this.get('ini_section'),
                        map: {
                            option: [{
                                key: key,
                                value: {
                                    item: [value]
                                }
                            }]
                        }
                    }]
                };

            var xhr = App.xhr.post('/api/10.2/set_lexmap', data, function (d, r) {
                cb && cb(d);
            });
            // kill request after 6 sec.
            setTimeout(function () {
                xhr.abort();
            }, 6000);
        },
        isPrimary: function () {
            return this.collection && this.collection.PRIMARY_COMPONENTS[this.get('app')] > 0;
        }
    });

    App.collection.Components = Backbone.Collection.extend({
        model: App.model.Component,
        url: '/api/10.2/appinfo',
        checkSubData: function () {
            this.models.forEach(function (m) {
                var app = m.get('app'),
                    url = COMP_DATA_HOST[app];

                if (url && COMP_DATA_PROP[app] && m.get('pid')) { // check data for working components only
                    App.xhr.get(url, null, function (d, r) {
                        var list = COMP_DATA_PROP[app];

                        for (var i = 0; i < list.length; i++) {
                            d && m.set(list[i], d[list[i]]);
                        }
                    }.bind(this), 'json');
                }
            }.bind(this));
        },
        // Remove not exist models, and add new models
        // Attention: Collection::set Can't be use because it merge changed models, but if  
        loadData3: function (installedCollection, cb) {
            // Last stable version
            /*App.xhr.get(this.url, null, function(d, r){
                if(d && d.appinfo){
                    var     installed = installedCollection.models.map(function(m){return m.toJSON();});
                    var     hash = {},
                            finalList = [],
                            toAddList = [],
                            buf, key, i;
    
                    // merge installed and appinfo list at one and filter by black list:
                    i = d.appinfo.length;
                    while(i-- > 0){
                        buf = d.appinfo[i];
                        if(!COMP_BLACK_LIST[buf.app]){
                            // Attention: define properties to trigger model change event. Without it, component switching can be broken
                            if(!buf.hasOwnProperty('switch_on_time'))   buf.switch_on_time = undefined;
                            if(!buf.hasOwnProperty('pid'))  buf.pid = undefined;
                            if(!buf.hasOwnProperty('exit_time'))    buf.exit_time = undefined;
                            if(!buf.hasOwnProperty('exit_code'))    buf.exit_code = undefined;
    
                            hash[buf.app] = buf;    
                        }
                    }
                    i = installed.length;
                    while(i-- > 0){
                        buf = installed[i];
                        if(!COMP_BLACK_LIST[buf.app]){
                            if(!hash[buf.app]){
                                hash[buf.app] = buf;
                            }else{
                                for(key in buf){
                                    hash[buf.app][key] = buf[key];
                                }   
                            }
                        }
                    }
    
                    for(key in hash){
                        finalList.push(hash[key]);
                    }
    
                    console.log('[CALL loadData]');
                    console.group();
                    console.dir(installed);
                    console.dir(d.appinfo);
                    console.dir(finalList);
                    console.groupEnd();
    
                    this.set(finalList);
                    this.trigger('resort', this);
                }
            }.bind(this), 'json');*/
            App.xhr.get(this.url, null, function (d, r) {
                if (d && d.appinfo) {
                    var i = d.appinfo.length,
                        instData,
                        out = [],
                        added = {},
                        appData;

                    // console.log('[CALL loadData]');
                    // console.group();
                    // console.log('Installed:\n%s', installedCollection.map(o => o.get('app')).join(','));
                    // console.dir(installedCollection);
                    // console.log('Appinfo:\n%s', d.appinfo.map(o=> o.app).join(','));
                    // console.dir(d.appinfo);
                    // console.groupEnd();      

                    while (i-- > 0) {
                        appData = d.appinfo[i];

                        if (!COMP_BLACK_LIST[appData.app]) {
                            if (instData = installedCollection.get(appData.app)) {
                                Object.assign(appData, instData.toJSON()); // TODO add poilifill
                            }
                            if (!appData.hasOwnProperty('switch_on_time')) appData.switch_on_time = undefined;
                            if (!appData.hasOwnProperty('pid')) appData.pid = undefined;
                            if (!appData.hasOwnProperty('exit_time')) appData.exit_time = undefined;
                            if (!appData.hasOwnProperty('exit_code')) appData.exit_code = undefined;
                            if (!appData.hasOwnProperty('extension')) appData.extension = undefined;
                            out.push(appData);
                            added[appData.app] = 1;
                        }
                    }
                    i = installedCollection.models.length;
                    while (i-- > 0) { // Complete not runned components

                        appData = installedCollection.models[i].toJSON();

                        if (!added[appData.app] && !COMP_BLACK_LIST[appData.app]) {
                            // appData.switch_on_time  = undefined;
                            //  appData.pid             = undefined;
                            // appData.exit_time       = undefined;
                            // appData.exit_code       = undefined;
                            out.push(appData);
                        } else {
                            appData.switch_on_time = undefined;
                            appData.pid = undefined;
                            appData.exit_time = undefined;
                            appData.exit_code = undefined;
                        }
                    }

                    this.set(out);
                    this.trigger('resort', this);
                }
            }.bind(this), 'json');
        },
        sort_priority: {
            APP_SCAN_ENGINE: 1,
            APP_NET_CHECK: 2,
            APP_HTTPD: 3,
            APP_CLAMD: 4,
            APP_ICAPD: 5,
            APP_SMB_SPIDER: 6,
            APP_GATED: 7,
            APP_MAILD: 8,
            APP_MAC_GUI: 9,
            APP_MAC_SPIDER: 10,
            APP_LINUX_GUI: 11,
            APP_LINUX_SPIDER: 12,
            APP_LINUX_NSS: 13,
            APP_COMMAND_LINE_TOOL: 14,
            APP_ESCAN: 15,

            // For DEBUG
            APP_ESAGENT: 13,
        },
        PRIMARY_COMPONENTS: { // exist and priority for sort
            APP_SMB_SPIDER: 6,
            APP_LINUX_NSS: 6,
            APP_LINUX_SPIDER: 5,
            APP_MAC_SPIDER: 5,
            APP_ICAPD: 4,
            APP_LINUX_FIREWALL: 3,
            APP_MAC_FIREWALL: 3,
            APP_CLAMD: 2,
            APP_CONFIGD: 1,
        },
    });

    var BaseComponentView = App.view.base.extend({
        initialize: function () {
            App.view.base.prototype.initialize.call(this);

            this.listenTo(this.model, 'change', function (m) {
                if (this.controls.connectionRow) {
                    if (m.changed.server_host != undefined || m.changed.server_port != undefined) {
                        this.controls.connectionHost.text(m.changed.server_host + ':' + m.changed.server_port);
                        this.controls.connectionRow.show();
                    } else {
                        this.controls.connectionRow.hide();
                    }
                }

                if (m.changed.exit_time != undefined || m.changed.swicth_on_time != undefined || m.changed.pid != undefined) {
                    this.stateWork(this.model.isWork());
                }

                if (m.changed.swicth_on_time != undefined) {
                    this.stateDisable(this.model.isDisable());
                }

                if (m.changed.exit_time != undefined || m.changed.exit_code != undefined || m.changed.ini_start != undefined || m.changed.pid != undefined || m.changed.extension) {
                    this.stateError(this.model.isBroken(), this.model.isExtension());
                }
            });

            this.listenTo(this.model, 'destroy', function () {
                this.remove();
            });

            this.stateWork(this.model.isWork());
            this.stateError(this.model.isBroken(), this.model.isExtension());
            this.stateDisable(this.model.isDisable());

            if (this.stat_map) {
                var options = this.stat_map[this.model.get('app')],
                    i, frag, methodName;

                if (Array.isArray(options)) {
                    i = options.length;

                    while (i-- > 0) {
                        methodName = 'render_' + options[i];
                        frag = this[methodName] && this[methodName]();
                        this.controls.optionRow && this.controls.optionRow.append(frag);
                    }
                }
            }
        },
        stateWork: function (isWork) {
            var intKey, method;

            if (isWork) {
                intKey = 'component_started';
                method = 'remove';
            } else {
                intKey = this.model.get('ini_start') ? 'Disabled' : 'component_not_started';
                method = 'add';
            }
            if (this.model.get('ini_start')) {
                this.controls.switcher.prop('checked', isWork);
            }

            this.controls.workStatus.text(App.helpers._(intKey)).data('i18', intKey).attr('data-i18', intKey);
            this.el.classList[method]('__off');
        },
        stateError: function (isBroken, isExtension) {
            var errorCode;

            if (isExtension) {
                var extension = this.model.get('extension'),
                    sub_comp_name;
                for (var prop in extension) {
                    if (prop.indexOf('_state') != -1) {
                        if (extension[prop] != 'EC_OK' && extension[prop] != 'EC_UNKNOWN_STATE') {
                            errorCode = extension[prop];
                            sub_comp_name = prop.split('_')[0];
                            break;
                        }
                    }
                }
            }

            if (isBroken) {
                errorCode = this.model.get('exit_code');

                var forceStart = this.model.get('ini_start') == 'Yes';

                if (forceStart) {
                    this.controls.switcher.prop('checked', forceStart);
                }
            }

            if (errorCode) {
                var labelText = App.helpers._(errorCode);
                if (sub_comp_name) {
                    labelText += ' (' + SUB_COMPONENTS[sub_comp_name] + ')';
                }
                this.controls.errorStatus.text(labelText).data('i18', errorCode).attr('data-i18', errorCode);
                this.el.classList.add('__error');

                if (PRIMARY_COMPONENTS[this.model.get('app')]) { // stretch row
                    this.controls.workStatus.parent().attr('colspan', 3);
                } else if (this.controls.optionRow) {
                    this.controls.optionRow.hide();
                }
            } else {
                if (PRIMARY_COMPONENTS[this.model.get('app')]) { // stretch row
                    this.controls.workStatus.parent().removeAttr('colspan');
                } else if (this.controls.optionRow) {
                    this.controls.optionRow.show();
                }

                this.stateWork(this.model.isWork());
                this.el.classList.remove('__error');
            }
        },
        stateDisable: function (isDisable) {
            if (this.model.get('ini_start')) {
                var $tumbler = this.controls.switcher && this.controls.switcher[0];

                $tumbler.classList[isDisable ? 'add' : 'remove']('__disabled');
            }
        },
        events: {
            'change .co-checkbox': function (e) {
                // we need check __error btn, but not disabled buttons;)
                // if(e.target.classList.contains('__error')) return;
                e.preventDefault();

                var _page = App.helpers.generateBulkPage(),
                    originalState = e.target.checked;

                // Function is turn Off
                // if(!originalState && !e.target.classList.contains('__disabled')){
                //  App.helpers.confirm(App.helpers._('Turn_off_the_component'), App.helpers._('Component_will_cease_to'), function(){
                //      e.target.disabled = true;
                //      this.model.changeState(false, function(d, app, status){
                //          e.target.disabled = false;

                //          if(!d){ // maybe backend now at best world...
                //              window.location.href = _page;
                //          }else if(App.errorHandle(d) === true){
                //              App.user.set('user', '');
                //          } 
                //      });
                //  }.bind(this), function(){});
                // }else{
                //  e.target.disabled = true;
                //  this.model.changeState(true, function(d, app, status){
                //      e.target.disabled = false;
                //      if(!d){ // maybe backend now at best world...
                //          window.location.href = _page;
                //      }
                //  });
                // }

                e.target.disabled = true;
                this.model.changeState(originalState, function (d, app, status) {
                    e.target.disabled = false;

                    if (!d) { // maybe backend now at best world...
                        window.location.href = _page;
                    }
                });
            },
            'click [data-co=error-status]': function (e) {
                var errorCode = this.controls.errorStatus.data('i18');
                ErrorInfo.open(errorCode);
            },
        },
        EC_HASH: {
            EC_OK: 0,
            EC_MONITOR_IPC_ERROR: 1,
            EC_ALREADY_IN_PROGRESS: 2,
            EC_IN_PENDING_STATE: 3,
            EC_INTERRUPTED_BY_USER: 4,
            EC_CANCELED: 5,
            EC_LINK_DISCONNECTED: 6,
            EC_BAD_MESSAGE_SIZE: 7,
            EC_BAD_MESSAGE_FORMAT: 8,
            EC_NOT_READY: 9,
            EC_NOT_INSTALLED: 10,
            EC_UNEXPECTED_MESSAGE: 11,
            EC_PROTOCOL_VIOLATION: 12,
            EC_NOT_ABSOLUTE_PATH: 20,
            EC_NO_MEMORY: 21,
            EC_IO_ERROR: 22,
            EC_NO_SUCH_ENTRY: 23,
            EC_PERMISSION_DENIED: 24,
            EC_NOT_A_DIRECTORY: 25,
            EC_DATA_CORRUPTED: 26,
            EC_FILE_EXISTS: 27,
            EC_READ_ONLY_FS: 28,
            EC_NETWORK_ERROR: 29,
            EC_NOT_A_DRIVE: 30,
            EC_UNEXPECTED_EOF: 31,
            EC_FILE_WAS_CHANGED: 32,
            EC_NOT_A_REGULAR_FILE: 33,
            EC_NAME_ALREADY_IN_USE: 34,
            EC_HOST_OFFLINE: 35,
            EC_BASE_CORRUPTED: 40,
            EC_OLD_BASE_VERSION: 41,
            EC_EMPTY_BASE: 42,
            EC_CAN_NOT_BE_CURED: 43,
            EC_INVALID_BASE_SET: 44,
            EC_SCAN_LIMIT_REACHED: 45,
            EC_AUTH_FAILED: 47,
            EC_NOT_AUTHORIZED: 48,
            EC_INVALID_TOKEN: 49,
            EC_INVALID_ARGUMENT: 60,
            EC_INVALID_OPERATION: 61,
            EC_ROOT_ONLY: 62,
            EC_STANDALONE_MODE_ONLY: 63,
            EC_NON_SUPPORTED_OS: 64,
            EC_NOT_IMPLEMENTED: 65,
            EC_UNKNOWN_OPTION: 66,
            EC_UNKNOWN_SECTION: 67,
            EC_INVALID_OPTION_VALUE: 68,
            EC_INVALID_STATE: 69,
            EC_NOT_LIST_OPTION: 70,
            EC_INVALID_TAG: 71,
            EC_RECORD_NOT_FOUND: 80,
            EC_RECORD_BUSY: 81,
            EC_QUARANTINED_FILE: 82,
            EC_BAD_DRL_FILE: 90,
            EC_BAD_LST_FILE: 91,
            EC_BAD_LZMA_FILE: 92,
            EC_PROXY_AUTH_ERROR: 93,
            EC_NO_UPDATE_SERVERS: 94,
            EC_BAD_KEY_FORMAT: 95,
            EC_EXPIRED_KEY: 96,
            EC_NETWORK_TIMEDOUT: 97,
            EC_BAD_CHECKSUM: 98,
            EC_BAD_TRIAL_KEY: 99,
            EC_BLOCKED_LICENSE: 100,
            EC_BAD_LICENSE: 101,
            EC_BAD_CONFIG: 102,
            EC_BAD_EXECUTABLE: 104,
            EC_NO_CORE_ENGINE: 105,
            EC_NO_VIRUS_BASES: 106,
            EC_APP_TERMINATED: 107,
            EC_APP_CRASHED: 108,
            EC_INCOMPATIBLE: 109,
            EC_BAD_VADERETRO_LIB: 110,
            EC_NO_LOOKUPD: 115,
            EC_NO_VPND: 116,
            EC_NO_GATED: 117,
            EC_NO_MAILD: 118,
            EC_NO_SCAN_ENGINE: 119,
            EC_NO_FILE_CHECK: 120,
            EC_NO_ESAGENT: 121,
            EC_NO_FIREWALL: 122,
            EC_NO_NET_CHECK: 123,
            EC_NO_CLOUDD: 124,
            EC_UNEXPECTED_ERROR: 125,
            EC_NO_KERNEL_MODULE: 113, // TODO
        },
        stat_map: {
            APP_SCAN_ENGINE: ['task_stat'], // 'max_forks' is turn off
            APP_NET_CHECK: ['error_stat', 'file_stat'],
            // APP_NET_CHECK: ['scanned_bytes', 'scanned_files'],
            APP_HTTPD: ['error_stat', 'file_stat'],
            APP_CLAMD: ['error_stat', 'file_stat'],
            APP_ICAPD: ['error_stat', 'file_stat'],
            APP_SMB_SPIDER: ['error_stat', 'file_stat'],
            APP_GATED: ['error_stat', 'file_stat'],
            APP_MAILD: ['error_stat', 'file_stat'],
            APP_MAC_GUI: ['error_stat', 'file_stat'],
            APP_MAC_SPIDER: ['error_stat', 'file_stat'],
            APP_LINUX_GUI: ['error_stat', 'file_stat'],
            APP_LINUX_SPIDER: ['error_stat', 'file_stat'],
            APP_LINUX_NSS: ['error_stat', 'file_stat'],
            APP_COMMAND_LINE_TOOL: ['error_stat', 'file_stat'],
            APP_ESCAN: ['error_stat', 'file_stat'],
        },
    });

    App.view.PrimaryComponent = BaseComponentView.extend({
        tagName: 'tr',
        template:
            '<td>' +
            '<a href="#settings/<%=obj.ini_section%>" class="dwc_elements_link" data-i18="<%=obj.app%>"><%=obj.name%></a>' +
            '</td>' +
            '<td>' +
            '<% if(obj.startable){ %>' +
            '<label class="dwc-switcher m3_middle">' +
            '<input type="checkbox" class="co-checkbox" data-co="switcher">' +
            '<span class="dwc-switcher_back"></span>' +
            '<span class="dwc-switcher_btn"></span>' +
            '</label>' +
            '<% } %>' +
            '<span class="dwc_elements_work-status" data-co="work-status"></span>' +
            '<a href="javascript:void(0)" class="dwc_elements_error-status" data-co="error-status" data-i18="Error"></a>' +
            '</td>' +
            '<td data-co="file-stat" class="dwc_elements_stats"></td><td data-co="error-stat" class="dwc_elements_stats"></td>'
        ,
        render_file_stat: function () {
            this.listenTo(this.model, 'change:file_stat', function (m, stat) {
                this.controls.fileStat.text(stat);
            });
            this.controls.fileStat.text(this.model.get('file_stat'));
        },
        render_error_stat: function () {
            this.listenTo(this.model, 'change:error_stat', function (m, stat) {
                this.controls.errorStat.text(stat);
            });
            this.controls.errorStat.text(this.model.get('error_stat'));
        },
    });

    App.view.PrimaryGateComponent = BaseComponentView.extend({
        tagName: 'tr',
        template:
            '<td colspan="4" class="firewall-block">' + '<table>' +
            '<tr>' +
            '<td>' +
            '<a href="#settings/<%=obj.ini_section%>" class="dwc_elements_link" data-i18="<%=obj.app%>"><%=obj.name%></a>' +
            '</td>' +
            '<td>' +
            '<span class="dwc_elements_work-status" data-co="work-status"></span>' +
            '<a href="javascript:void(0)" class="dwc_elements_error-status" data-co="error-status" data-i18="Error"></a>' +
            '</td>' +
            '<td data-co="file-stat" class="dwc_elements_stats"></td><td data-co="error-stat" class="dwc_elements_stats"></td>' + '</tr>' +
            '<tr>' +
            '<td>' + '<span data-i18="outbound_connections">' + App.helpers._('outbound_connections') + '</span>' + '</td>' +
            '<td colspan="3">' + '<label class="dwc-switcher m3_middle">' +
            '<input type="checkbox" class="co-checkbox_out" data-co="checkbox_out">' +
            '<span class="dwc-switcher_back"></span>' +
            '<span class="dwc-switcher_btn"></span>' +
            '</label>' + '<span class="dwc_elements_protection-status" data-co="protection-status_out"></span>' + '</td>' +
            '</tr>' +
            '<tr class="incoming_connections">' +
            '<td>' + '<span  data-i18="incoming_connections">' + App.helpers._('incoming_connections') + '</span>' + '</td>' +
            '<td>' + '<label class="dwc-switcher m3_middle">' +
            '<input type="checkbox" class="co-checkbox_in" data-co="checkbox_in">' +
            '<span class="dwc-switcher_back"></span>' +
            '<span class="dwc-switcher_btn"></span>' +
            '</label>' + '<span class="dwc_elements_protection-status" data-co="protection-status_in"></span>' + '</td>'
            + '<td colspan="2" data-co="setting-col" class="settingCol">' + '<span data-co="settingName"></span>' + '<span id="settingName"></span>' + '<span data-co="settingValue"></span>' + '<span id="settingValue"></span>' + '<button class="dwc_btn change-btn" data-i18="change_btn">' + App.helpers._('change_btn') + '</button>' + '</td>' +
            '</tr>' +
            '</table>' + '</td>',
        startable: new StartableComponents(),
        initialize: function () {
            App.view.base.prototype.initialize.call(this);
            this.startable.fetch();
            this.listenTo(App.bus, 'refresh', function (e) {
                if (e.event == 'lexmap') {
                    this.startable.fetch();
                }
            });

            this.listenTo(this.model, 'change', function () {

                //this.startable.attributes.LinuxFirewall - need more time or promise

                if (this.startable.attributes.LinuxFirewall !== undefined) {
                    this.startableListen();
                }
            });

            this.listenTo(this.startable, 'change', function (m) {
                if (m.changed.exit_time != undefined || m.changed.swicth_on_time != undefined || m.changed.pid != undefined) {
                    this.stateWork(this.model.isWork());
                }
                this.startableListen();
            });
        },

        startableListen: function () {
            var LinuxFirewall = this.startable.attributes.LinuxFirewall;

            if (LinuxFirewall.InputDivert == 'Off' && LinuxFirewall.OutputDivert == 'Off') {
                this.$el.addClass('__off');
                this.controls.workStatus.text(App.helpers._('Disabled')).attr('data-i18', 'Disabled');
            } else {
                this.$el.removeClass('__off');
                this.controls.workStatus.text(App.helpers._('component_started')).attr('data-i18', 'component_started');
            }

            if (LinuxFirewall.OutputDivert == 'Off') {
                this.controls.checkbox_out.prop('checked', false);
                this.controls.protectionStatus_out.text(App.helpers._('no_protected')).attr('data-i18', 'no_protected');
                this.controls.protectionStatus_out.addClass('no-protection');
            } else {
                this.controls.checkbox_out.prop('checked', true);
                this.controls.protectionStatus_out.text(App.helpers._('protected')).attr('data-i18', 'protected');
                this.controls.protectionStatus_out.removeClass('no-protection');
            }

            if (LinuxFirewall.InputDivert == 'Off') {
                this.controls.checkbox_in.prop('checked', false);
                this.controls.protectionStatus_in.text(App.helpers._('no_protected')).attr('data-i18', 'no_protected');
                this.controls.protectionStatus_in.addClass('no-protection');
                this.controls.settingCol.hide();
            } else {
                this.controls.checkbox_in.prop('checked', true);
                this.controls.protectionStatus_in.text(App.helpers._('protected')).attr('data-i18', 'protected');
                this.controls.protectionStatus_in.removeClass('no-protection');

                var autoList = LinuxFirewall.InputDivert;
                var autoSettings = autoList.match(/\(interface:[\s]+([0-9A-z]+)[\s]+protected:[\s]+([0-9\,]+)/);
                var interface = autoSettings[1];
                var protected = autoSettings[2];

                this.controls.settingName.text(App.helpers._('Interface')).attr('data-i18', 'Interface');
                var settingName = document.getElementById("settingName");
                settingName.innerHTML = ': ' + interface + '; ';

                this.controls.settingValue.text(App.helpers._('Ports')).attr('data-i18', 'Ports');
                var settingValue = document.getElementById("settingValue");
                settingValue.innerHTML = ': ' + protected + ' ';

                this.controls.settingCol.show();
            }
        },
        events: {
            'click .co-checkbox_out': function (e) {
                var originalState = e.target.checked;

                e.target.setAttribute('data-' + 'key', 'OutputDivert');
                e.target.setAttribute('data-' + 'value', 'Auto, Off');

                var keyItem = e.target.dataset.key;
                var values = e.target.dataset.value.split(', ');

                e.target.disabled = true;
                this.model.changeState(originalState, function (d, app, status) {
                    e.target.disabled = false;
                }, values, keyItem);
            },
            'click .co-checkbox_in': function (e) {
                if (e.target.checked) {
                    var check = e.target,
                        firewall = this.model,
                        originalState = e.target.checked,
                        property = this.startable.attributes.LinuxFirewall.InputDivert;

                    require(['main.divert.popup'], function (popup) {
                        popup(property, check, firewall, originalState, function () {
                        });
                    }.bind(this));
                    return false;
                } else {
                    var originalState = e.target.checked;

                    e.target.setAttribute('data-' + 'key', 'InputDivert');
                    e.target.setAttribute('data-' + 'value', 'Auto, Off');

                    var keyItem = e.target.dataset.key;
                    var values = e.target.dataset.value.split(', ');

                    this.model.changeState(originalState, function (d, app, status) {
                        e.target.disabled = false;
                    }, values, keyItem);
                }
            },
            'click .change-btn': function (e) {
                var check = e.target,
                    firewall = this.model,
                    originalState = this.controls.checkbox_in.checked = true,
                    property = this.startable.attributes.LinuxFirewall.InputDivert;

                require(['main.divert.popup'], function (popup) {
                    popup(property, check, firewall, originalState, function () {
                    });
                }.bind(this));
            }
        }
    });

    // просроченная лицензия отразится на коде ошибки!
    // TODO проверить, подсунув битый файл
    App.view.AdditionalComponent = BaseComponentView.extend({
        className: 'dwc_additional_item',
        template:
            '<div class="dwc_additional_cell">' +
            '<% if(obj.ini_section){ %>' +
            '<a href="#settings/<%=obj.ini_section%>" class="dwc_elements_link dwc_elements_control-wrap" data-i18="<%=obj.app%>"><%=obj.name%></a>' +
            '<% }else{ %>' +
            '<span class="dwc_elements_title dwc_elements_control-wrap" data-i18="<%=obj.app%>"><%=obj.name%></span>' +
            '<% } %>' +
            '<div class="dwc_elements_control-wrap">' +
            '<% if(obj.startable){ %>' +
            '<label class="dwc-switcher m3_middle">' +
            '<input type="checkbox" class="co-checkbox" data-co="switcher">' +
            '<span class="dwc-switcher_back"></span>' +
            '<span class="dwc-switcher_btn"></span>' +
            '</label>' +
            '<% } %>' +
            '<span class="dwc_elements_work-status" data-co="work-status"></span>' +
            '<a href="javascript:void(0)" class="dwc_elements_error-status" data-co="error-status" data-i18="Error"></a>' +
            '</div>' +
            // Maybe this code is unused
            '<div data-co="connection-row" style="display:none;">' +
            '<div class="dwc_elements_property" data-i18="connection_point">' + App.helpers._('connection_point') + '</div>' +
            '<div class="dwc_elements_control-wrap" data-co="connection-host"></div>' +
            '</div>' +
            // new for additional data
            '<div data-co="option-row"></div>' +
            '</div>',
        render_file_stat: function () {
            var $node = document.createDocumentFragment(),
                div1 = document.createElement('div'),
                div2 = document.createElement('div');

            div1.className = 'dwc_elements_property';
            div1.setAttribute('data-i18', 'file_scan_speed');
            div1.textContent = App.helpers._('file_scan_speed');

            div2.className = 'dwc_elements_control-wrap dwc_elements_stats';

            $node.appendChild(div1);
            $node.appendChild(div2);
            this.controls.fileStat = $(div2);

            this.listenTo(this.model, 'change:file_stat', function (m, stat) {
                this.controls.fileStat.text(stat);
            });
            this.controls.fileStat.text(this.model.get('file_stat'));

            return $node;
        },
        render_error_stat: function () {
            var $node = document.createDocumentFragment(),
                div1 = document.createElement('div'),
                div2 = document.createElement('div');

            div1.className = 'dwc_elements_property';
            div1.setAttribute('data-i18', 'error_level');
            div1.textContent = App.helpers._('error_level');

            div2.className = 'dwc_elements_control-wrap dwc_elements_stats';

            $node.appendChild(div1);
            $node.appendChild(div2);
            this.controls.errorStat = $(div2);

            this.listenTo(this.model, 'change:error_stat', function (m, stat) {
                this.controls.errorStat.text(stat);
            });
            this.controls.errorStat.text(this.model.get('error_stat'));

            return $node;
        },
        render_task_stat: function () { // not supported yet
            var $node = document.createDocumentFragment(),
                div1 = document.createElement('div'),
                div2 = document.createElement('div');

            div1.className = 'dwc_elements_property';
            div1.setAttribute('data-i18', 'tasks_in_queue');
            div1.textContent = App.helpers._('tasks_in_queue');

            div2.className = 'dwc_elements_control-wrap dwc_elements_stats';
            div2.setAttribute('data-title', App.helpers._('tasks_in_queue_help'));
            div2.setAttribute('data-i18-attr', 'data-title:tasks_in_queue_help');

            $node.appendChild(div1);
            $node.appendChild(div2);
            this.controls.taskStat = $(div2);

            this.listenTo(this.model, 'change:task_stat', function (m, stat) {
                this.controls.taskStat.text(stat);
            });
            this.controls.taskStat.text(this.model.get('task_stat'));

            return $node;
        },
        render_max_forks: function () {
            var $node = document.createDocumentFragment(),
                div1 = document.createElement('div'),
                div2 = document.createElement('div');

            div1.className = 'dwc_elements_property';
            div1.setAttribute('data-i18', 'max_forks');
            div1.textContent = App.helpers._('max_forks');

            div2.className = 'dwc_elements_control-wrap dwc_elements_stats';

            $node.appendChild(div1);
            $node.appendChild(div2);
            this.controls.maxForks = $(div2);

            this.listenTo(this.model, 'change:max_forks', function (m, stat) {
                this.controls.maxForks.text(stat);
            });
            this.controls.maxForks.text(this.model.get('max_forks'));

            return $node;
        },
        // // DEPRICATED
        // render_scanned_files: function(){
        //  var     $node = document.createDocumentFragment(),
        //          div1 = document.createElement('div'),
        //          div2 = document.createElement('div'),
        //          scanned_files = this.model.get('scanned_files');

        //  div1.className = 'dwc_elements_property';
        //  div1.setAttribute('data-i18', 'scanned_files_stat');
        //  div1.textContent = App.helpers._('scanned_files_stat');

        //  div2.className = 'dwc_elements_control-wrap dwc_elements_stats';

        //  $node.appendChild(div1);
        //  $node.appendChild(div2);
        //  this.controls.scannedFiles = $(div2);

        //  this.listenTo(this.model, 'change:scanned_files', function(m, stat){
        //      this.controls.scannedFiles.text(stat != undefined ? stat : '');
        //  });
        //  this.controls.scannedFiles.text(scanned_files != undefined ? scanned_files : '');
        //  return $node;
        // },
        // // DEPRICATED
        // render_scanned_bytes: function(){
        //  var     $node = document.createDocumentFragment(),
        //          div1 = document.createElement('div'),
        //          div2 = document.createElement('div'),
        //          scanned_bytes = this.model.get('scanned_bytes'),
        //          bytesDimensions = ['vol_B', 'vol_Kb', 'vol_Mb', 'vol_Gb', 'vol_Tb'].map(function(k){return ' ' + App.helpers._(k);});

        //  div1.className = 'dwc_elements_property';
        //  div1.setAttribute('data-i18', 'scanned_bytes_stat');
        //  div1.textContent = App.helpers._('scanned_bytes_stat');

        //  div2.className = 'dwc_elements_control-wrap dwc_elements_stats';

        //  $node.appendChild(div1);
        //  $node.appendChild(div2);
        //  this.controls.scannedBytes = $(div2);
        //  this.listenTo(this.model, 'change:scanned_bytes', function(m, stat){
        //      this.controls.scannedBytes.text(stat != undefined ? App.helpers.formatBytes(stat, bytesDimensions) : '');
        //  });
        //  this.controls.scannedBytes.text(scanned_bytes != undefined ?  App.helpers.formatBytes(scanned_bytes, bytesDimensions) : '');

        //  return $node;
        // }
    });

    App.view.main = App.view.base.extend({
        className: 'dwc_mainpage clearfix',
        template:
            '<h1 class="dwc_page-title" data-i18="dashboard">' + App.helpers._('dashboard') + '</h1>' +
            '<table class="dwc_primary-elements" data-co="primary-block" style="display:none;">' +
            '<thead>' +
            '<tr>' +
            '<td data-i18="main_components">' + App.helpers._('main_components') + '</td>' +
            '<td data-i18="State">' + App.helpers._('State') + '</td>' +
            '<td><span class="dwc_primary-elements_hd" data-i18="speed_check">' + App.helpers._('speed_check') + '</span> <i class="dwc_help-icon dwc-tooltip __white" data-title="" data-i18-attr="data-title:scannedFiles"></i></td>' +
            '<td><span class="dwc_primary-elements_hd" data-i18="error_level">' + App.helpers._('error_level') + '</span> <i class="dwc_help-icon dwc-tooltip __white" data-title="" data-i18-attr="data-title:scannedErrors"></i></td>' +
            '</tr>' +
            '</thead>' +
            '<tbody data-co="primary-list"></tbody>' +
            '</table>' +
            '<div class="dwc_additional_wrap dwc_additional_container" data-co="additional-list"></div>' +
            '<div class="dwc_grid">' +
            '<div class="dwc_grid-cell dwc_grid-cell_h" data-co="updateinfo-block"></div>' +
            '<div class="dwc_grid-cell dwc_grid-cell_h" data-co="license-block"></div>' +
            '</div>' +
            '',
        startable: new StartableComponents(),
        initialize: function () {
            App.view.base.prototype.initialize.call(this);

            this.addSubView('updateinfoBlock', new App.view.updateBlock({
                model: new App.model.updateBlock({})
            }), 'updateinfo');
            this.addSubView('licenseBlock', new App.view.licenseBlock({
                model: new App.model.licenseBlock({})
            }), 'license');

            // fetch all models:
            ['license', 'updateinfo'].forEach(function (cid) {
                this.children[cid] && this.children[cid].model.loadData && this.children[cid].model.loadData();
            }.bind(this));

            this.listenTo(App.bus, 'refresh', function (e) {
                switch (e.event) {
                    case 'appstat': this.parseAverageLoad(e.event_data); break;
                    //// 'installed' DONE at indexPage
                    case 'appinfo':
                        // TODO Необходимо проверить  по event_data что не относится к es_agent-у (реагирует, на установку и удаление компонентов)
                        this.componentsCollection.loadData3(App.collection.installed);
                        break;
                    case 'lexmap':
                        this.startable.fetch();
                        break;
                    default: this.children[e.event] && this.children[e.event].model.loadData && this.children[e.event].model.loadData();
                }
            });

            this.componentsCollection = new App.collection.Components();
            // DEPRICATED use loadData2()
            /*this.listenTo(this.componentsCollection, 'reset', function(collection, r){
                console.log('[TRIGGER reset]');
                console.dir(arguments);
    
                var     appId,
                        model,
                        primaryCount = 0,
                        sortedModels = collection.models.sort(function(a, b){
                            var     weightA = PRIMARY_COMPONENTS[a.get('app')] || 0,
                                    weightB = PRIMARY_COMPONENTS[b.get('app')] || 0;
                            
                            return  weightA < weightB ? 1 : weightA > weightB ? -1 : 0;
                        });
    
                for(var i = 0, len = sortedModels.length; model = sortedModels[i], i < len; i++){
                    appId = model.get('app');
    
                    if(PRIMARY_COMPONENTS[appId]){
                        if(primaryCount == 0) this.controls.primaryBlock.show();// TODO show table
                        this.addSubView('primaryList', new App.view.PrimaryComponent({model: model}), model.get('pid'));
                        primaryCount++;
                    }else{
                        this.addSubView('additionalList', new App.view.AdditionalComponent({model: model}), model.get('pid'));
                    }
                }
    
                if(primaryCount == 0) this.controls.primaryBlock.hide();// TODO hide table
    
                sortedModels = null;
    
                // Destroy previous models
                r.previousModels.forEach(function(m){m.trigger('destroy');});
                
                collection.checkSubData();
                this.lexMapCollection.fetch({reset:true});
            });*/
            this.listenTo(this.componentsCollection, 'resort', function (c) {
                // Dividing by groups
                var groups = c.models.reduce(function (groups, model, index, array) {
                    groups[model.isPrimary() ? 'primary' : 'secondary'].push(model);
                    return groups;
                }, {
                        primary: [],
                        secondary: []
                    });

                // if(false){
                //  console.log('Before sort\n%s\n%s',
                //      groups.primary.map(m => m.get('app') + '(' + c.PRIMARY_COMPONENTS[m.get('app')] + ')').join(', '),
                //      groups.secondary.map(m => m.get('app') + '(' + c.sort_priority[m.get('app')] + ')').join(', ')
                //  );  
                // }
                groups.secondary.sort(function (a, b) {
                    var diff = (c.sort_priority[a.get('app')] || 0) - (c.sort_priority[b.get('app')] || 0);
                    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
                });
                groups.primary.sort(function (a, b) {
                    var diff = (c.PRIMARY_COMPONENTS[a.get('app')] || 0) - (c.PRIMARY_COMPONENTS[b.get('app')] || 0);
                    return diff > 0 ? 1 : diff < 0 ? -1 : 0;
                });
                var i = groups.primary.length,
                    app;

                while (i-- > 0) {
                    app = groups.primary[i].get('app');
                    // this.controls.primaryList.append(this.children[app].el);
                }

                i = groups.secondary.length;
                while (i-- > 0) {
                    app = groups.secondary[i].get('app');
                    this.controls.additionalList.append(this.children[app].el);
                }

                this.controls.primaryBlock[groups.primary.length > 0 ? 'show' : 'hide']();
                c.checkSubData();
                this.startable.fetch();
            });
            // Attention: here we add View by relative model without any sorting. Sorting implement at `resort` event listener
            this.listenTo(this.componentsCollection, 'add', function (m, c) {
                var app = m.get('app');

                if (COMP_STARTABLE[app]) {
                    var start = this.startable.get(COMP_STARTABLE[app]);
                    start && m.set('ini_start', start, { silent: true });
                }

                if (PRIMARY_COMPONENTS[app]) {
                    if (app == 'APP_LINUX_FIREWALL') {
                        this.addSubView('primaryList', new App.view.PrimaryGateComponent({ model: m }), app);
                        App.helpers.localize(this.el);
                    } else {
                        this.addSubView('primaryList', new App.view.PrimaryComponent({ model: m }), app);
                    }
                } else {
                    this.addSubView('additionalList', new App.view.AdditionalComponent({ model: m }), app);
                }
            });
            this.listenTo(this.componentsCollection, 'remove', function (m, c) {
                m.trigger('destroy');
            });
            this.listenTo(this.startable, 'change', function (m) {
                var components = this.componentsCollection.models,
                    i = components.length,
                    lexmapModel,
                    iniSection;

                while (i-- > 0) {
                    iniSection = components[i].get('ini_section');
                    lexmapModel = m.get(iniSection);

                    if (m.has(iniSection)) {
                        components[i].set('ini_start', m.get(iniSection));
                    }
                }
            });

            this.listenTo(App.collection.installed, 'reset', function (c) {
                this.componentsCollection.loadData3(c);
            });

            if (App.collection.installed.length == 0) {
                App.collection.installed.fetch({ reset: true });
            } else {
                this.componentsCollection.loadData3(App.collection.installed);
            }
            this.on('remove', function () {
                this.startable.destroy();
                this.componentsCollection.totalDestroy();
            });

            App.helpers.localizeAttr(this.el);
            this.startable.fetch();
        },
        parseAverageLoad: function (obj) {
            if (obj.root_stat) {
                var list = obj.root_stat && obj.root_stat.scan_load_average || [],
                    view,
                    updated = {
                        'APP_SCAN_ENGINE': 1, // updated by another object
                    },
                    i = list.length;

                while (i-- > 0) {
                    view = this.children[list[i].origin];

                    if (view && view.model) {
                        view.model.set({
                            file_stat: list[i].files_scanned.av_1min.toFixed(2) + ' / ' + list[i].files_scanned.av_5min.toFixed(2) + ' / ' + list[i].files_scanned.av_15min.toFixed(2),
                            error_stat: list[i].errors.av_1min.toFixed(2) + ' / ' + list[i].errors.av_5min.toFixed(2) + ' / ' + list[i].errors.av_15min.toFixed(2),
                        });
                        updated[view.model.get('app')] = 1;
                    }
                }

                this.componentsCollection.models.forEach(function (m) {
                    if (!updated[m.get('app')] && !m.compWithoutStat[m.get('app')]) {
                        if (m.isWork()) {
                            m.set({
                                file_stat: '0.00 / 0.00 / 0.00',
                                error_stat: '0.00 / 0.00 / 0.00'
                            });
                        } else {
                            m.set({
                                file_stat: '',
                                error_stat: ''
                            });
                        }
                    }
                });
            }/*else if(obj.ncheck_appstat){ // turn off, because netcheck use root stat
            var     view = this.children[obj.app],
                    scanned_files, scanned_bytes,
                    i, scan;

            if(view){
                if(obj.ncheck_appstat.client){
                    i = obj.ncheck_appstat.client.length;
                    scanned_files = 0;
                    scanned_bytes = 0;
                    
                    while(i-- > 0){
                        if(scan = obj.ncheck_appstat.client[i] && obj.ncheck_appstat.client[i].scan){
                            scanned_files += scan.scanned_files; // attention: speed value - files between two measurements
                            scanned_bytes += scan.scanned_bytes;
                        }
                    }
                }
                view.model.set('scanned_files', scanned_files);
                view.model.set('scanned_bytes', scanned_bytes);
            }
        }*//*else if(obj.fcheck_stat){
            console.log('FileCheck stat');
            console.dir(obj.fcheck_stat);

            var     list = obj.fcheck_stat.scan,
                    files = 0,
                    view = this.children[obj.app],
                    i;

            // if(Array.isArray(list)){
            //  i = list.length;
            //  while(i-- > 0){
            //      files += list[i].scanned_files;
            //  }
            //  view.model.set({
            //      file_stat: files + ''
            //  });
            // }
        }*/else if (obj.se_stat) {
                var view = this.children[obj.app],
                    buf = {},
                    statList = obj.se_stat.qstat,
                    i;

                if (Array.isArray(statList)) {
                    i = statList.length;
                    while (i-- > 0) {
                        buf[statList[i].queue] = statList[i].base + statList[i].in - statList[i].out;
                    }
                }

                view && view.model && view.model.set('task_stat', (buf.LOW || ' \u2014 ') + ' / ' + (buf.MEDIUM || ' \u2014 ') + ' / ' + (buf.HIGH || ' \u2014 '));
            }
        },

    });

    return App.view.main;
});