define(['app', 'uicontrols'], function(App, $AppUI){
	var ProtectionModel = Backbone.Model.extend({
		defaults: {
			connecting_with_server: '',
			log: null,
		},
		url: '/api/10.2/esagent_appinfo',
		fetch: function(conf){
			App.xhr.get(this.url, {}, function(d, r){
				if(d){
					if(Object.keys(d).length == 0){
						this.clear({silent: true});
						this.trigger('reset', this);
					}else{
						this.set(d);						
					}
				} else if(r.sessionComplete){
					return;	
				} // else another troubles
			}.bind(this), 'json');
		},
		disconnect: function(){
			App.xhr.post('/api/10.2/esdisconnect', null, function(d, r){
				if(d){
					this.trigger('disconnect', this);
				} else if(r.sessionComplete){
					return;	
				} // else another troubles
			}.bind(this), 'json');
		},
		connect: function(conf, next){
			this._xhr_connect = App.xhr.post('/api/10.2/esconnect', conf, function(d, r){
				if(d){
					d.error && d.error.code && this.trigger('connect_error', this, d.error.code);
					next && next();
				} else if(r.sessionComplete){
					return;	
				} // else another troubles
			}.bind(this), 'json');
		},
		connectConfig: function(data, next){
			App.xhr.objPost({
				url: '/api/10.2/esconnect_config',
				resFormat: 'json',
				params: data,
				oncomplete: function(d, r){
					if(d){
						d.error && d.error.code && this.trigger('connect_error', this, d.error.code);
						next && next();
					} else if(r.sessionComplete){
						return;	
					} // else another troubles
				}.bind(this)
			});
		},
		abortConnect: function(){
			if(this._xhr_connect && this._xhr_connect.abort){
				this._xhr_connect.abort();
			}
		}
	});
	
	function DrDate(time){
		this.now = time ? new Date(time * 1000) : new Date();
	}
	DrDate.prototype.h = function(){return this.now.getHours();};
	DrDate.prototype.m = function(){return this.now.getMinutes();};
	DrDate.prototype.s = function(){return this.now.getSeconds();};
	DrDate.prototype.withZero = function(n){return (n < 10 ? '0': '') + n;};
	DrDate.prototype.hh = function(){return this.withZero(this.now.getHours())};
	DrDate.prototype.mm = function(){return this.withZero(this.now.getMinutes());};
	DrDate.prototype.ss = function(){return this.withZero(this.now.getSeconds());};

	var 	_modelInstance = new ProtectionModel(),
			_ns = {};

	// BASE64 implemebtation
	(function(global) {
	    'use strict';
	    // existing version for noConflict()
	    var _Base64 = global.Base64;
	    
	    // constants
	    var b64chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
	    var b64tab = function(bin) {
	        var t = {};
	        for (var i = 0, l = bin.length; i < l; i++) t[bin.charAt(i)] = i;
	        return t;
	    }(b64chars);
	    var fromCharCode = String.fromCharCode;
	    // encoder stuff
	    var cb_utob = function(c) {
	        if (c.length < 2) {
	            var cc = c.charCodeAt(0);
	            return cc < 0x80 ? c
	                : cc < 0x800 ? (fromCharCode(0xc0 | (cc >>> 6))
	                                + fromCharCode(0x80 | (cc & 0x3f)))
	                : (fromCharCode(0xe0 | ((cc >>> 12) & 0x0f))
	                   + fromCharCode(0x80 | ((cc >>>  6) & 0x3f))
	                   + fromCharCode(0x80 | ( cc         & 0x3f)));
	        } else {
	            var cc = 0x10000
	                + (c.charCodeAt(0) - 0xD800) * 0x400
	                + (c.charCodeAt(1) - 0xDC00);
	            return (fromCharCode(0xf0 | ((cc >>> 18) & 0x07))
	                    + fromCharCode(0x80 | ((cc >>> 12) & 0x3f))
	                    + fromCharCode(0x80 | ((cc >>>  6) & 0x3f))
	                    + fromCharCode(0x80 | ( cc         & 0x3f)));
	        }
	    };
	    var re_utob = /[\uD800-\uDBFF][\uDC00-\uDFFFF]|[^\x00-\x7F]/g;
	    var utob = function(u) {
	        return u.replace(re_utob, cb_utob);
	    };
	    var cb_encode = function(ccc) {
	        var padlen = [0, 2, 1][ccc.length % 3],
	        ord = ccc.charCodeAt(0) << 16
	            | ((ccc.length > 1 ? ccc.charCodeAt(1) : 0) << 8)
	            | ((ccc.length > 2 ? ccc.charCodeAt(2) : 0)),
	        chars = [
	            b64chars.charAt( ord >>> 18),
	            b64chars.charAt((ord >>> 12) & 63),
	            padlen >= 2 ? '=' : b64chars.charAt((ord >>> 6) & 63),
	            padlen >= 1 ? '=' : b64chars.charAt(ord & 63)
	        ];
	        return chars.join('');
	    };
	    var btoa = global.btoa ? function(b) {
	        return global.btoa(b);
	    } : function(b) {
	        return b.replace(/[\s\S]{1,3}/g, cb_encode);
	    };
	    var _encode = function(u){return btoa(utob(u))};
	    var encode = function(u, urisafe) {
	        return !urisafe
	            ? _encode(String(u))
	            : _encode(String(u)).replace(/[+\/]/g, function(m0) {
	                return m0 == '+' ? '-' : '_';
	            }).replace(/=/g, '');
	    };
	    var encodeURI = function(u) { return encode(u, true) };
	    // decoder stuff
	    var re_btou = new RegExp([
	        '[\xC0-\xDF][\x80-\xBF]',
	        '[\xE0-\xEF][\x80-\xBF]{2}',
	        '[\xF0-\xF7][\x80-\xBF]{3}'
	    ].join('|'), 'g');
	    var cb_btou = function(cccc) {
	        switch(cccc.length) {
	        case 4:
	            var cp = ((0x07 & cccc.charCodeAt(0)) << 18)
	                |    ((0x3f & cccc.charCodeAt(1)) << 12)
	                |    ((0x3f & cccc.charCodeAt(2)) <<  6)
	                |     (0x3f & cccc.charCodeAt(3)),
	            offset = cp - 0x10000;
	            return (fromCharCode((offset  >>> 10) + 0xD800)
	                    + fromCharCode((offset & 0x3FF) + 0xDC00));
	        case 3:
	            return fromCharCode(
	                ((0x0f & cccc.charCodeAt(0)) << 12)
	                    | ((0x3f & cccc.charCodeAt(1)) << 6)
	                    |  (0x3f & cccc.charCodeAt(2))
	            );
	        default:
	            return  fromCharCode(
	                ((0x1f & cccc.charCodeAt(0)) << 6)
	                    |  (0x3f & cccc.charCodeAt(1))
	            );
	        }
	    };
	    var btou = function(b) {
	        return b.replace(re_btou, cb_btou);
	    };
	    var cb_decode = function(cccc) {
	        var len = cccc.length,
	        padlen = len % 4,
	        n = (len > 0 ? b64tab[cccc.charAt(0)] << 18 : 0)
	            | (len > 1 ? b64tab[cccc.charAt(1)] << 12 : 0)
	            | (len > 2 ? b64tab[cccc.charAt(2)] <<  6 : 0)
	            | (len > 3 ? b64tab[cccc.charAt(3)]       : 0),
	        chars = [
	            fromCharCode( n >>> 16),
	            fromCharCode((n >>>  8) & 0xff),
	            fromCharCode( n         & 0xff)
	        ];
	        chars.length -= [0, 0, 2, 1][padlen];
	        return chars.join('');
	    };
	    var atob = global.atob ? function(a) {
	        return global.atob(a);
	    } : function(a){
	        return a.replace(/[\s\S]{1,4}/g, cb_decode);
	    };
	    var _decode = function(a){return btou(atob(a))};
	    var decode = function(a){
	        return _decode(
	            String(a).replace(/[-_]/g, function(m0) { return m0 == '-' ? '+' : '/' })
	                .replace(/[^A-Za-z0-9\+\/]/g, '')
	        );
	    };// Base64.encode
	    var noConflict = function() {
	        var Base64 = global.Base64;
	        global.Base64 = _Base64;
	        return Base64;
	    };
	    // export Base64
	    global.Base64 = {
	        atob: atob,
	        btoa: btoa,
	        fromBase64: decode,
	        toBase64: encode,
	        utob: utob,
	        encode: encode,
	        encodeURI: encodeURI,
	        btou: btou,
	        decode: decode,
	        noConflict: noConflict
	    };
	    // if ES5 is available, make Base64.extendString() available
	    if (typeof Object.defineProperty === 'function') {
	        var noEnum = function(v){
	            return {value:v,enumerable:false,writable:true,configurable:true};
	        };
	        global.Base64.extendString = function () {
	            Object.defineProperty(
	                String.prototype, 'fromBase64', noEnum(function () {
	                    return decode(this)
	                }));
	            Object.defineProperty(
	                String.prototype, 'toBase64', noEnum(function (urisafe) {
	                    return encode(this, urisafe)
	                }));
	            Object.defineProperty(
	                String.prototype, 'toBase64URI', noEnum(function () {
	                    return encode(this, true)
	                }));
	        };
	    }
	})(_ns);

	// Attention: This code crash Chrome if file very BIG:
	// function b64EncodeUnicode(str) {
	// 	return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g, function(match, p1) {
	// 		return String.fromCharCode('0x' + p1);
	// 	}));
	// }

	return App.view.base.extend({
		model: _modelInstance,
		template: 
			'<div class="dwc_thr_header-wrap">' +
				'<h2 class="dwc_set_comp" data-co="set-title" data-i18="central_protection_mode">' + App.helpers._('central_protection_mode') + '</h2>' +
			'</div>' +
			'<div data-co="set-list" class="clearfix dwc_set_list">' +
				'<div class="dwc_prot-mode-desc" data-i18="description_central_protection_mode">' + App.helpers._('description_central_protection_mode') + '</div>' +
				'<div class="dwc_settings_row">' +
					'<div class="dwc_settings_cell"><div class="dwc_settings_title" data-i18="enable_central_protection_mode">' + App.helpers._('enable_central_protection_mode') + '</div></div>' +
					'<label class="dwc_settings_cell dwc_chbox">' + 
						'<input type="checkbox" data-co="enable-box" data-component="switcher" data-true="Yes" data-false="No"><span class="dwc_chbox-icn"></span>' +
					'</label>' +
				'</div>' +
				'<div data-co="connection-block" style="display:none;">' +
					'<div class="dwc_settings_row __short" data-co="protection-server" style="display:none;">' +
						'<div class="dwc_settings_cell">' + App.helpers._('cpm_protection_server') + '</div>' +
						'<div class="dwc_settings_cell" data-co="label-host"></div>' +
					'</div>' +
					'<div class="dwc_settings_row __short" data-co="con-status-wrap">' +
						'<div class="dwc_settings_cell">' + App.helpers._('cpm_connection_status') + '</div>' +
						'<div class="dwc_settings_cell">' +
							'<h4 class="dwc_prot-mode_conn-status" data-co="con-status"></h4>' +
							'<textarea class="dwc_prot-mode_log" data-co="log" style="display:none;"></textarea>' +
						'</div>' +
					'</div>' +
				'</div>' +
			'</div>',
		events: {
			'click [data-co="enable-box"]': function(e){
				e.preventDefault();
				var 	$checkbox = e.target,
						_model = this.model;

				if(e.target.checked){
					var 	variantsList = App.helpers._('cpm_variants_list'),
							variants = variantsList.split(';'),
							_model = this.model;

					new $AppUI.BasePopupView({
						class: 'dec_wt-popup',
						content: // main content
						'<button data-co="close" class="dwc_popup-close"></button>' +
						'<form class="dwc-form" data-co="form">' +
							'<a href="javascript:void(0)" class="dwc_dropdown dwc_title-dropdown" data-co="connection-type" data-component="dropdown" data-value="' + variants[1] + '" data-id="' + variants[0] + '" data-list="' + variantsList + '"></a>' +

							'<div data-co="address-wrap">' +
								'<p class="dwc-form_offset2 dwc_popup_label1">' + App.helpers._('cpm_server_address')+ '</p>' +
								'<div class="dwc_validation-input" data-warning=""><input type="text" class="dwc_validation-input_text" data-co="server-address" autocomplete="on"></div>' +
							'</div>' +
							'<div data-co="config-wrap">' +
								'<p class="dwc-form_offset2 dwc_popup_label1">' + App.helpers._('cpm_server_public_key_file') + '</p>' +
								'<div class="dwc-form_offset1" data-co="server-key-uploader"></div>' +
								'<div class="dwc_settings_group">' +
									'<input type="checkbox" class="dwc_settings_group-checkbox">' +
									'<h3 class="dwc_settings_group-title __cpm" data-co="auth-switcher">' + App.helpers._('cpm_authentication') + '</h3>' +
									'<div class="dwc_settings_group-members">' + 
										// workstation id:
										'<p class="dwc-form_offset2 dwc_popup_label1">' + App.helpers._('cpm_workstation_id') + '</p>' +
										'<div class="dwc_validation-input" data-warning=""><input type="text" class="dwc_validation-input_text" data-co="workstation-id" autocomplete="off"></div>' +
										// password
										'<p class="dwc-form_offset2 dwc_popup_label1">' + App.helpers._('cpm_password') + '</p>' +
										'<div class="dwc_validation-input" data-warning=""><input type="password" class="dwc_validation-input_text" data-co="password" autocomplete="off"></div>' +
										// as newbie
										'<label class="dwc_chbox"><input type="checkbox" data-co="enable-box" data-component="switcher" ><span class="dwc_chbox-i"></span>' +
											'<span class="dwc_prot-mode_newbie">' + App.helpers._('cpm_connect_as_newbie') + '</span>' +
										'</label>' +
									'</div>' +
								'</div>' +
							'</div>' +
							'<div data-co="configfile-wrap" style="display:none;">' +
								// configuration file path:
								'<p class="dwc-form_offset2 dwc_popup_label1">' + App.helpers._('cpm_configuration_file_path') + '</p>' +
								'<div class="dwc-form_offset1" data-co="configuration-file-uploader"></div>' +
							'</div>' +		
							'<div class="dwc_login-view_error" data-co="error" style="display:none;"></div>' +
							'<div class="dwc-form_btn-wrap __left"><button class="dwc_btn __green" type="submit" data-co="submit-btn" disabled>' + App.helpers._('Connect') + '</button><button class="dwc_btn" data-co="cancel">' + App.helpers._('Cancel') + '</button></div>' +
						'</form>' +
						'',
						onopen: function(view){
							view.controls.form.on('submit', function(e){
								e.preventDefault();
								
								var 	conf = {},
										connectionType = view.controls.connectionType[0].dataset.id,
										file, readHandler, 
										fr = new FileReader();

								view.listenToOnce(_model, 'change:connecting_with_server change:accepted_by_server change:pending_on_server', function(m){
									_model.set('is_lock', false);
									view.close();
								});
								view.listenToOnce(_model, 'connect_error', function(m, ec){
									_model.set('is_lock', false);
									this.controls.error.show().text(App.helpers._(ec));
									// this._errorTimeOut = setTimeout(function(){
									// 	this.controls.error.hide();
									// }.bind(this), 5000);
								});

								if(connectionType == '1'){
									conf.server = view.controls.serverAddress.val();
								}

								if(connectionType == '1' || connectionType == '2'){
									if(view.controls.enableBox.prop('checked')){
										conf.newbie = true;
									}else if(view.controls.workstationId.val()){
										conf.login = view.controls.workstationId.val();
										conf.password = view.controls.workstationId.val();
									}

									fr.onload = function(e){
										var data64 = _ns.Base64.encode(e.target.result);

										conf.public_key = data64;
										_model.connect(conf);
									};

									if(file = view._serverPublicKey && view._serverPublicKey[0]){
										fr.readAsText(file);
									}else{
										conf.public_key = '';
										_model.connect(conf);
									}
								}else if(connectionType == '3'){
									fr.onload = function(e){
										_model.connectConfig(e.target.result);
									};
									if(file = view._configurationFile && view._configurationFile[0]){
										fr.readAsText(file);	
									}
								}
									
								_model.set('is_lock', true);
								view.controls.error.hide();
							});

							// ##1:
							var _serverPublicKeyUploader = new $AppUI.FileUploaderView({
								btnLabel:  App.helpers._('Review'), 
								onchange: function(value, e, files){
									_serverPublicKeyUploader.addWarning();
									view._serverPublicKey = files.length > 0 && files;
									// if(view.controls.connectionType[0].dataset.id == '1'){
									// 	_model.set('is_lock', files.length == 0);
									// }
								}
							});
							view.controls.serverKeyUploader.append(_serverPublicKeyUploader.el);

							// ##2:
							var _configurationFileUploader = new $AppUI.FileUploaderView({
								btnLabel:  App.helpers._('Review'), 
								onchange: function(value, e, files){
									_configurationFileUploader.addWarning();
									view._configurationFile = files.length > 0 && files;

									if(view.controls.connectionType[0].dataset.id == '3'){
										_model.set('is_lock', files.length == 0);	
									}
								}
							});
							view.controls.configurationFileUploader.append(_configurationFileUploader.el);

							view.on('remove', function(){
								_serverPublicKeyUploader.remove();
								_configurationFileUploader.remove();
							});

							view.listenTo(_model, 'change:is_lock', function(m, isLock){
								this.controls.submitBtn.prop('disabled', isLock);
							});

							_model.set('is_lock', true);
						},
						onclose: function(view){
							view._errorTimeOut && clearTimeout(view._errorTimeOut);
						},
						_events: {
							'authSwitcher click': function(e){
								var 	$checkbox = e.target.previousElementSibling;
								
								$checkbox.checked = !$checkbox.checked;
							},
							'close click': function(e){
								e.stopPropagation();
								e.preventDefault();
								this.close();
							},
							'cancel click': function(e){
								e.stopPropagation();
								e.preventDefault();
								this.close();
								_model.abortConnect();
							},
							'enableBox change': function(e){
								if(e.target.checked){
									this.controls.workstationId.prop('disabled', true);
									this.controls.password.prop('disabled', true);
								}else{
									this.controls.workstationId.prop('disabled', false);
									this.controls.password.prop('disabled', false);
								}
							},
							'connectionType dropdownselected': function(e){
								var 	value = e.target.dataset.id;


								if(value == '1'){
									this.controls.addressWrap.show();
								}else{
									this.controls.addressWrap.hide();
								}

								if(value == '3'){
									_model.set('is_lock', !this._configurationFile);
									this.controls.configfileWrap.show();
									this.controls.configWrap.hide();
								}else{
									if(value == 1) {
										// 
										// _model.set('is_lock', !this._serverPublicKey);
										_model.set('is_lock', !this.controls.serverAddress.val());
									} else {
										_model.set('is_lock', false);
									}
									this.controls.configfileWrap.hide();
									this.controls.configWrap.show();
								}
								this.controls.error.hide();
							},
							'serverAddress input': function(e){
								if(this.controls.connectionType.data('id') == 1){
									this.controls.submitBtn.prop('disabled', e.target.value.length == 0);
								}
							}
						}
					}).open();
				}else{
					App.helpers.confirm(
						App.helpers._('cpm_central_protection_disabling'), 
						App.helpers._('cpm_disable_central_protection_mode'), 
						function(){
							_model.disconnect();
						}.bind(this));
				}
			}
		},
		initialize: function(){
			this.model.fetch();

			App.view.base.prototype.initialize.call(this);

			this.listenTo(this.model, 'reset', function(m){
				this.controls.enableBox.prop('checked', false);
				this.controls.protectionServer.hide();
				this.controls.log.hide();
				this.controls.connectionBlock.hide();
			});
			this.listenTo(this.model, 'disconnect', function(m){
				this.controls.enableBox.prop('checked', false);
			});
			this.listenTo(this.model, 'change:connecting_with_server', function(m, host){
				if(host != undefined){
					this.controls.connectionBlock.show();
					this.controls.labelHost.text(host);
					this.controls.protectionServer.show();
					this.controls.log.show();
					this.controls.enableBox.prop('checked', true);
					this.controls.conStatus.text(App.helpers._('cpm_status_connecting')).attr('data-status', 'connecting');
				}else{
					this.controls.protectionServer.hide();
					this.controls.log.hide();
				}
			});
			this.listenTo(this.model, 'change:accepted_by_server', function(m, host){
				if(host != undefined){
					this.controls.labelHost.text(host);
					this.controls.protectionServer.show();
					this.controls.log.show();
					this.controls.conStatus.text(App.helpers._('cpm_status_connected')).attr('data-status', 'connected');
					this.controls.enableBox.prop('checked', true);
					this.controls.connectionBlock.show();
				}
			});
			this.listenTo(this.model, 'change:pending_on_server', function(m, value){
				if(value){
					this.controls.labelHost.text(value);
					this.controls.protectionServer.show();
					this.controls.log.show();
					this.controls.conStatus.text(App.helpers._('cpm_status_pending')).attr('data-status', 'pending');
					this.controls.enableBox.prop('checked', true);
					this.controls.connectionBlock.show();
				}
			});
			this.listenTo(this.model, 'change:log', function(m, log){
				var 	i = log && log.length,
						template, now, conf,
						text = '';

				while(i--){
					now = new DrDate(log[i].time);
					conf = {
						hh: now.hh(),
						mm: now.mm(),
						ss: now.ss(),
					};

					if(log[i].paused_ms){
						template = App.helpers._('cpm_message_next_attempt');
						conf.ms = log[i].paused_ms;
					}else if(log[i].connecting){
						template = App.helpers._('cpm_message_connecting');
					}else if(log[i].error){
						template = App.helpers._('cpm_message_error');
						conf.error = App.helpers._(log[i].error);
					}else if(log[i].connected_ok){
						template = App.helpers._('cpm_message_connected');
					}else{ // I don't know
						template = '{hh}:{mm}:{ss} wtf!??'; 
					}
					text += App.helpers.i18transformer(template, conf);
				}

				this.controls.log.text(text);
			});
			this.listenTo(App.bus, 'refresh', function(e){
				if(e.event == 'appinfo'){ // TODO add condition for esagent
					if(Array.isArray(e.event_data) && e.event_data.indexOf('APP_ESAGENT') != -1){
						this.model.fetch();
					}
				}
			});

			var original = this.model.toJSON();
			// this.model.trigger('change:connecting_with_server', this.model, original.connecting_with_server);
			// this.model.trigger('change:log', this.model, original.log);
			this.model.clear({silent: true});
		},
	});
});
