define(['app', 'uicontrols'], function(App, $AppUI){
	// Popup for configs of RepackPassword for MailD

//====================================================================
// Wrapper for dropdown
//====================================================================
function Dropdown(el, properties){
	if(!(this instanceof Dropdown)) return new Dropdown(el, properties);

	this.el = el[0] || el;
	this.hash = {};

	for(var i = 0, buf = properties.split(';'); i < buf.length; i += 2){
		this.hash[buf[i]] = buf[i + 1];
	}
	this.el.setAttribute('data-list', properties);
	this.el.dataset.list = properties;
}
Dropdown.prototype.set = function(id){
	this.el.setAttribute('data-id', id);
	this.el.dataset.id = id;
	this.el.setAttribute('data-value', this.hash[id]);
	this.el.dataset.value = this.hash[id];
	return this;
};
Dropdown.prototype.get = function(){
	return this.el.dataset.id;
};
Dropdown.prototype.disable = function(undo){
	this.el.classList[undo ? 'remove' : 'add']('__disabled');
};

function parsePassword(str){
	var 	pos = str.indexOf('('),
			out = {}

	if(pos != -1){
		out.name = str.substring(0, pos);
		out.arg = str.substring(pos + 1, str.length - 1);
	}else{
		out.name = str;
	}
	return out;
}
function capitalizeFirst(s){
	return s.charAt(0).toUpperCase() + s.slice(1);
}

//====================================================================
// Popup
//====================================================================
	return function(property, initValue, onSibmit){
		var 	ISOUTPUT = property == 'OutputDivert',
				MENU_LIST_TOKENS = 'mrp_mode-select',
				_ValueModel = parsePassword(initValue[0]);

		console.log('PARSE: %s', initValue[0]);

		new $AppUI.BasePopupView({
			class: 'dec_wt-popup',
			content: 
			'<form class="dwc-form" data-co="form">' +
				'<button class="dwc_popup-close" type="reset"></button>' +
				'<a href="javascript:void(0)" class="dwc_dropdown dwc_title-dropdown" data-co="select" data-component="dropdown"></a>' + 
				'<div class="dwc_login-view_error" data-co="error" style="display:none;">' + App.helpers._('mrp_unvalid-pass') + '</div>' +
				'<p data-co="description" class="dwc-mrp_description"></p>' +
				'<div class="dwc-mrp_pass-row" data-co="pass-row">' +
					'<span data-co="pass-label" class="dwc-mrp_pass-label"></span>' +
					'<input class="dwc-mrp_pass" type="text" data-co="pass-input"/>' +
				'</div>' +
				'<p class="dwc-mrp_warning">' + App.helpers._('mrp_warning') + '</p>' +
				'<div class="dwc-form_btn-wrap __left">' + 
					'<button class="dwc_btn __green" type="submit">' + App.helpers._('save_btn') + '</button>' +
					'<button class="dwc_btn" data-co="cancel" type="reset">' + App.helpers._('Cancel') +'</button>' +
				'</div>' +
			'</form>' +
			'',
			onopen: function(view){
				console.log('OPEN: %s %s', MENU_LIST_TOKENS, App.helpers._(MENU_LIST_TOKENS));
				console.dir(_ValueModel);
				view._select = new Dropdown(view.controls.select[0], App.helpers._(MENU_LIST_TOKENS));
				view._select.set(capitalizeFirst(_ValueModel.name)); // configure (Parse value)
				view.controls.select.trigger('dropdownselected');
			},
			onclose: function(view){
				_ValueModel = null;
			},
			_events: {
				'form submit': function(e){
					e.preventDefault();
					var		selected = this._select.get(),
							settingLine = selected,
							inputed = this.controls.passInput.val();
					
					console.log('Submit %s', selected);


					if(selected != 'None'){
						if(inputed){
							this.controls.error.hide();
							settingLine += '(' + inputed.replace(/\)/g, '\)').replace(/\(/g, '\(') + ')';
						}else{
							this.controls.error.show();
							return;
						}
					}else{
						this.controls.error.hide();
						
					}
					onSibmit(settingLine);
					this.close();
				},	
				'form reset': function(e){
					e.preventDefault();
					this.close();
				},
				'select dropdownselected': function(){
					var 	selected = this._select.get(),
							descriptionId;

					switch(selected){
						case 'HMAC': 
							descriptionId = 'mrp_hmac-description'; 
							this.controls.passRow.show();
							this.controls.passLabel.text(App.helpers._('mrp_label-secret'));
							this.controls.passInput.val(_ValueModel.name == 'HMAC' ? _ValueModel.arg : '');
							break;
						case 'Plain': 
							descriptionId = 'mrp_plain-description'; 
							this.controls.passRow.show();
							this.controls.passLabel.text(App.helpers._('mrp_label-pass'));
							this.controls.passInput.val(_ValueModel.name == 'Plain' ? _ValueModel.arg : '');
							break;
						case 'None': 
							descriptionId = 'mrp_none-description'; 
							this.controls.passRow.hide();
							break;
					}
					this.controls.description.text(App.helpers._(descriptionId));
				},
			}
		}).open();
	}
});
